﻿/*global Framework7, Dom7, Template7, moment, hnapi */

(function (Framework7, $$, T7, moment, hnapi) {
    'use strict';
    //$('html head').append('<link rel="stylesheet" href="css/project/' + Template7.global.websiteID + '.css">')
    var resaultLoginPage = "login", menuListWrapperClone;
    // Helpers
    T7.registerHelper('time_ago', function (datetime) {
        var dateObj = new Date(parseInt(datetime.substr(6)));

        return moment.utc(dateObj).fromNow();
    });
    T7.registerHelper('tmpl', function (data, options) {
        var compiledTemplate = Template7.compile($$('#' + options.hash.tmplname + 'Template').html());

        return compiledTemplate(data);
    });
    T7.registerHelper('setPriceCama', function (data) {
        return setPriceCama(data) + " تومان";
    });
    T7.registerHelper('SttUrlWithoutSpace', function (data) {
        return SttUrlWithoutSpace(data);
    });
    T7.registerHelper('setProductDiscountPrice', function (price, discount) {
        return setPriceCama(price - (price * discount / 100)) + " تومان";
    });
    T7.registerHelper('DiscountPriceWithTax', function (ProductCount, Price, AmazzingPrice, Discount) {
        return setPriceCama((AmazzingPrice != null ? Price - AmazzingPrice : Price * Discount / 100)) + " تومان";
    });
    T7.registerHelper('priceWithTaxDiscount', function (ProductCount, Price, TaxPercent) {
        return setPriceCama((TaxPercent == null ? Price : Price + (Price * TaxPercent / 100))) + " تومان";
    });
    T7.registerHelper('productDiscountWithTaxPercent', function (ProductCount, InstallmentID, AmazzingPrice, Price, TaxPercent, Discount) {
        var priceWithTaxDiscount = (TaxPercent == null ? Price : Price + (Price * TaxPercent / 100));
        return setPriceCama((InstallmentID != null ? priceWithTaxDiscount : AmazzingPrice != null ? AmazzingPrice + (Price * TaxPercent / 100) : priceWithTaxDiscount - (Price * Discount / 100))) + " تومان";
    });
    T7.registerHelper('getPersianDate', function (date) {
        return getPersianDate(date);
    });
    T7.registerHelper('setProductPlanList', function (ProductPlans, PlanIDSelected) {
        return setProductPlanList(ProductPlans, PlanIDSelected);
    });
    T7.registerHelper('checkPlanSelected', function (PlanIDList, PlanIDSelected) {
        return PlanIDList.indexOf(PlanIDSelected) != -1 ? "checked" : "";
    });
    T7.registerHelper('dispayAmazingOffer', function (ExpireDateTime) {
        return (ExpireDateTime != null) ? "display:block;" : "display:none;";
    });
    T7.registerHelper('calculateAmazzingDiscount', function (BasePrice, AmazingPrice) {
        return calculateAmazzingDiscount(BasePrice, AmazingPrice);
    });

    function setProductPlanList(ProductPlans, PlanIDSelected) {

        if (typeof PlanIDSelected == undefined || PlanIDSelected == null)
            PlanIDSelected = '';
        var ProductPlanGroupList = [];
        var hiddenInput = "";
        $.each(ProductPlans, function (i, el) {
            var stringOptionInput = '';
            var selected = '';
            if (PlanIDSelected == el.PlanID)
                selected = 'selected';
            if (PlanIDSelected == '') {
                PlanIDSelected = el.PlanID;
                selected = 'selected';
            }


            $.each(el.productPlanOptionListModel, function (i, kl) {
                stringOptionInput += ' data-gr' + kl.OGroupID + '=' + kl.POptionID;
                var ProductPlanGroup = getObjects(ProductPlanGroupList, "OGroupID", kl.OGroupID);
                if (ProductPlanGroup == "") {
                    ProductPlanGroupList.push({
                        OGroupID: kl.OGroupID,
                        OGroupName: kl.OGroupName,
                        OSiteGroupName: kl.OSiteGroupName,
                        ProductPlanOption: [],
                        PlanIDSelected: PlanIDSelected

                    })
                    ProductPlanGroup = getObjects(ProductPlanGroupList, "OGroupID", kl.OGroupID);
                }
                var productPlanOptionObject = getObjects(ProductPlanGroup.ProductPlanOption, "POptionID", kl.POptionID);
                if (productPlanOptionObject == "") {
                    ProductPlanGroup.ProductPlanOption.push({
                        POptionID: kl.POptionID,
                        POptionName: kl.POptionName,
                        PlanIDList: [kl.PlanID],
                        Picture: kl.Picture
                    })
                }
                else
                    productPlanOptionObject.PlanIDList.push(kl.PlanID)

                $.each(ProductPlans, function (i, el2) {
                    if (getObjects(el2.productPlanOptionListModel, "OGroupID", kl.OGroupID) == "") {
                        var productPlanOptionObject2 = getObjects(ProductPlanGroup.ProductPlanOption, "POptionID", 0);
                        if (productPlanOptionObject2 == "") {
                            ProductPlanGroup.ProductPlanOption.push({
                                POptionID: 0,
                                POptionName: "بدون " + kl.OSiteGroupName,
                                PlanIDList: [el2.PlanID],
                                Picture: null
                            })
                        }
                        else {
                            if (productPlanOptionObject2.PlanIDList.indexOf(el2.PlanID) == -1)
                                productPlanOptionObject2.PlanIDList.push(el2.PlanID)
                        }

                    }


                })


            });


            var dispayamazingoffer = '';
            if (typeof el.AmazingPrice != undefined && el.AmazingPrice != null)
                dispayamazingoffer = "data-amazingprice=" + el.AmazingPrice + " data-amazingtitle=" + el.AmazingTitle + " data-expiredatetime=" + el.ExpireDateTime;


            hiddenInput += '<input type="hidden" data-planavailable="' + el.PlanAvailable + '" data-id="' + el.PlanID + '" id="plan' + el.PlanID + '"  ' + stringOptionInput +
                ' data-selected="' + selected + '"  value="' + el.price + '" ' + dispayamazingoffer + '>'



        });


        var output = '';
        var compiledTemplate = Template7.compile($$('#planGroupTemplate').html());

        $.each(ProductPlanGroupList, function (i, el) {

            output += compiledTemplate(el);
        })

        return output + hiddenInput;
    }


    var planID = 0;
    $$(document).on('change', '.planGroup_wrapper [id^=planOption]', function (e) {


        setPlanDetails($(this))
    })
    //$('[id^=color]').live("click", function () {
    //    setPlanDetails($(this), 'gurantee')
    //})
    function setPlanDetails($elem) {

        //$elem.parent().parent().parent().find('label[for^=planOption]').removeClass('checked')
        //$elem.next().addClass('checked')
        var selected = false;

        //planOption_72_1074
        var elemGroupID = $elem.attr('id').split('_')[1];
        var elemID = $elem.attr('id').split('_')[2];
        var counter = 0;

        var planFilter = "[data-gr" + elemGroupID + "=" + elemID + "]"; //
        if (elemID == 0)
            planFilter = "";
        while (counter < $('.planGroup_wrapper').length) {
            var $planGroup = $('.planGroup_wrapper').eq(counter)
            var planGroupID = $planGroup.attr('data-id')
            if ((elemGroupID != planGroupID)) {
                var currentElemSelectedID = $planGroup.find('label[class="checked"]').prev().val()
                if (currentElemSelectedID == "0")
                    currentElemSelectedID = $planGroup.find('label:not([val="0"]):first').prev().val()
                var newPlanFilter = planFilter + "[data-gr" + planGroupID + "=" + currentElemSelectedID + "]";
                if ($('input[type=hidden][id^=plan]' + newPlanFilter).length > 0)
                    planFilter = newPlanFilter;

            }
            counter++;
        }
        var currentPlan = $('input[type=hidden][id^=plan]' + planFilter).eq(0);
        var planID = currentPlan.attr('data-id')
        $('.planGroup_wrapper label[for^=planOption]').removeClass('checked')
        counter = 0;
        while (counter < $('.planGroup_wrapper').length) {
            var $planGroup = $('.planGroup_wrapper').eq(counter)
            var planGroupID = $planGroup.attr('data-id')
            var planGroupValue = currentPlan.attr('data-gr' + planGroupID)
            if (planGroupValue == null)
                planGroupValue = '0';
            $('.planGroup_wrapper label[for=planOption_' + planGroupID + '_' + planGroupValue + ']').addClass('checked')

            counter++;
        }


        //var plans = $elem.attr('data-planidlist').split(',');

        //for (i = 0 ; i < plans.length; i++) {

        //    if (!selected)
        //    {
        //        var element = $('.planGroup_wrapper [id^=planOption][data-planidlist*="' + plans[i] + '"]:not([id=' + $elem.attr('id') + '])')

        //        if (element.length == $('.planGroup_wrapper').length - 1) {
        //            planID = plans[i]
        //            element.attr('checked', 'checked').next().addClass('checked')
        //            selected = true;
        //        }

        //    }

        //}

        var price = parseInt($('#plan' + planID).val());
        var planAvailable = $('#plan' + planID).attr('data-planavailable');
        $('.ProductFeature .add_to_chart,.ProductFeature #InstallmentListLink').attr('data-planavailable', planAvailable)
        if (planAvailable == "true") {
            $('#body-main-features-available a').removeClass('planNotAvailable')
            $('#product_Price').parent().removeClass('planNotAvailable')
        }
        else {
            $('#body-main-features-available a').addClass('planNotAvailable')
            $('#product_Price').parent().addClass('planNotAvailable')
        }


        $('input[type=hidden][id^=plan]').attr('data-selected', '')
        $('#plan' + planID).attr('data-selected', 'selected')
        if ($('#InstallmentListLink').length) {
            var illHref = $('#InstallmentListLink').attr('href')
            illHref = illHref.substring(0, illHref.indexOf('planID')) + "planID=" + planID;
            $('#InstallmentListLink').attr('href', illHref)
        }

        var discounbt = $('#Product_Discount').attr('data-discount');
        if (discounbt == null)
            discounbt = 0;
        var endPrice = price - (price * parseInt(discounbt) / 100);
        endPrice -= endPrice % 100;
        $('#product_Price').html(("" + price).replace(/\B(?=(\d{3})+(?!\d))/g, ",") + " تومان");

        var amazingPrice = $('#plan' + planID).attr('data-amazingprice');
        var expiredatetime = $('#plan' + planID).attr('data-expiredatetime');
        var intexpiredatetime = parseCsharpDate(expiredatetime, true);
        if (amazingPrice != null && amazingPrice > 0 && intexpiredatetime > 0) {
            $('#Product_Discount').html(("" + (price - amazingPrice)).replace(/\B(?=(\d{3})+(?!\d))/g, ",") + " تومان");
            $('#Product_EndPrice').html(("" + amazingPrice).replace(/\B(?=(\d{3})+(?!\d))/g, ",") + "تومان");
            $('.amazing-offer-detail').show()


            $('.amazing-offer-detail .clock').before('<div id="pFeatureOclock" class="clock" data-expiredatetime="' + expiredatetime + '"></div>').remove()
            $('.amazing-offer-detail h3').html($('#plan' + planID).attr('data-amazingtitle'))
            $('.amazing-offer-detail .amazing-offer-ticket .btn.ticket').html(calculateAmazzingDiscount(price, amazingPrice))

            AmazingofferContentLoad($elem.parent().parent().parent().parent())
        }
        else {
            $('#Product_EndPrice').html(("" + endPrice).replace(/\B(?=(\d{3})+(?!\d))/g, ",") + "تومان");
            $('#Product_Discount').html(discounbt + "%")
            $('.amazing-offer-detail').hide()
        }
    }
    function calculateAmazzingDiscount(price, amazingPrice) {
        var currency = "تومان";
        var discount = price - amazingPrice;
        if (discount >= 10000) {
            discount = discount / 1000;
            currency = "هزار تومان";
        }
        return '<span class="num">' + discount + '</span><span class="currency">' + currency + '</span><span>تخفیف</span>'

    }

    function parseDate(input) {
        var parts = input.match(/(\d+)/g);
        // new Date(year, month [, date [, hours[, minutes[, seconds[, ms]]]]])
        return new Date(parts[0], parts[1] - 1, parts[2], parts[3], parts[4], parts[5]); // months are 0-based
    }
    function parseCsharpDate(dateString) {
        if (dateString == null)
            return "";
        if (dateString.indexOf('Date') != -1)
            return GetTimerTime(dateString);


        var date = parseDate(dateString)
        var now = new Date();
        var diff = date.getTime() / 1000 - now.getTime() / 1000;
        return diff
    }
    function GetTimerTime(datetime) {
        var date = new Date(parseInt(datetime.substr(6)));
        var now = new Date();
        var diff = date.getTime() / 1000 - now.getTime() / 1000;

        return diff
    }

    T7.registerHelper('setDynamicLink', function (TempName, MenuID, Title, LinkUrl) {
        var href = "";
        switch (TempName) {
            case "PageContent":
                href = "PageContent.html?id=" + MenuID + "&menuName=" + Title;
                break;
            case "ProductListM":
                href = "ProductListM.html?id=" + getURLParameter(LinkUrl, "menuID");
                break;
            case "ProductFeature":
                href = "ProductDetails.html?id=" + (LinkUrl.indexOf("/p/") == -1 ? getURLParameter(LinkUrl, "productID") : LinkUrl.split('/')[2])
                break;
            case "":
                href = ""
                break;
        }


        return href;
    });


    T7.registerHelper('setPaymentReviewPrice', function (postPrice, discount, TotalInstallmentPrepaymentPrice) {
        if (TotalInstallmentPrepaymentPrice == null)
            TotalInstallmentPrepaymentPrice = 0;
        var price = this.TotalBasePrice
        if (discount != null)
            price = price - (price * discount / 100) + TotalInstallmentPrepaymentPrice;
        if (validation.isNumber(postPrice))
            price += parseInt(postPrice);

        return price

    });
    T7.registerHelper('setPaymentPriceCama', function (postPrice, discount, TotalInstallmentPrepaymentPrice) {
        if (TotalInstallmentPrepaymentPrice == null)
            TotalInstallmentPrepaymentPrice = 0;
        var price = this.TotalBasePrice
        if (discount != null)
            price = price - (price * discount / 100) + TotalInstallmentPrepaymentPrice;
        if (validation.isNumber(postPrice))
            price += parseInt(postPrice);

        return setPriceCama(price) + " تومان";
    });
    T7.registerHelper('ValidationIsNumber', function (PostPrice) {
        if (!validation.isNumber(PostPrice))
            return PostPrice
        else
            setPriceCama(PostPrice) + " تومان";
    });


    T7.registerHelper('MenuInGroupList', function (menuID) {
        var menuListRepository = JSON.parse(window.localStorage.getItem('MenuListRepository'));

        var resualt = [];
        var counter = 0;
        menuListRepository.menuList.forEach(function (object, index) {
            if (object.MenuID == parseInt(menuID)) {
                resualt[counter] = object
                counter++;
            }

        })

        var compiledTemplate = Template7.compile($$('#MenuInGroupListTemplate').html());

        return compiledTemplate({ menus: resualt });
    });




    var mainView, leftView, allowCommentsInsert, basketID, planIDCountInChart = [], $mainPage, selectedUserAddressID, selectedPostID, bascketNofication;



    // Init App
    var ah7App = new Framework7({
        modalTitle: 'Ah7developer',
        animateNavBackIcon: true,

        //precompileTemplates: true,
        //template7Pages: true,
        externalLinks: 'a.external',
        // router: true,
        // swipePanel: 'right',
        cache: true,
        pushState: true,
        pushStateOnLoad: false,

    });


    if (window.localStorage.getItem('lrCode') == null) {

        //  var ipc = new myapp.pages.IndexPageController(ah7App, $$); // welcome page




    }

    //else if (window.localStorage.getItem('VerifyPhoneNumber') == null) {


    //    setTimeout(function () {
    //        $$('.btnuserProfuleView').click()
    //        profileView.loadPage('Register.html')

    //        $$('#register-container').hide();
    //        $$('#AddPhoneNumber_Wrapper').show()

    //    }, 500)

    //}



    // Add Right/Main View
    mainView = ah7App.addView('#mainView', {
        dynamicNavbar: true
    });
    var menuListView = ah7App.addView('#MenuListView', { dynamicNavbar: true });
    var bascketView = ah7App.addView('#bascketView', { dynamicNavbar: true });
    var profileView = ah7App.addView('#profileView', { dynamicNavbar: true });


    $$(document).on('onPageBeforeInit', function (e) {
        var page = e.detail.page;

    });
    $$(document).on('pageInit', function (e) {
        var page = e.detail.page;
        //if ($mainPage == null)
        //    $mainPage = $('.page[data-page="index"]');

        //if ($('.page[data-page="index"]').length == 0) {
        //    $('#mainView .pages').prepend()
        //}
        if (page.name == "index") {

            var a = ah7App.getCurrentView().selector;
            if (ah7App.getCurrentView().selector == "#bascketView") {
                setChartData();
            }
            else {
                $('#loading_img').show()
                getPageContent(-1, false, "index");
            }

        }
        else if (page.name == "newsText") {
            var newsRepository = JSON.parse(window.localStorage.getItem('newsRepository'));
            var newsID = getURLParameter(page.url, "id");
            var model = getObjects(newsRepository, "NewsID", parseInt(newsID))
            var $elem = $$(page.container).find('.page-content .single-product-area');
            generateBoxTemplate("newsText", model, $elem)
            $elem.find('.readmore').remove();
            $elem.find('article').append('<div class="preloader"></div>');
        }
        else if (page.name == "pageContent") {
            $('#loading_img').show()
            var menuID = getURLParameter(page.url, "id");
            var menuName = getURLParameter(page.url, "menuName");
           
            ah7App.showTab('#mainView');
            $$(page.container).find('.page-content').attr('data-menuid', menuID)
            //var viewName = ah7App.getCurrentView().selector
            var viewName = getURLParameter(page.url, "viewName");

            if (viewName == "menuListView")
                $$(page.navbarInnerContainer).html('<div class="left"><a href="#" class="link icon-only open-panel"> <i class="icon icon-bars"></i></a></div><div class="center sliding" style="left: 97px;">منوی غذا</div>')
            else if (menuID == -1)

                $$(page.navbarInnerContainer).html('<div class="left sliding"><a href="#" class="open-panel link icon-only"> <i class="icon icon-bars"></i></a></div> <div class="center sliding" >خانه</div><div style="width: 44px;"></div>')
            else {

                $$(page.navbarInnerContainer).find('.center.sliding').html(menuName)
            }

            getPageContent(menuID, false, page.name);

        }
        else if (page.name == "ProductDetails") {
            var productID = getURLParameter(page.url, "id");


            ah7App.showTab('#mainView');

            var $elem = $$(page.container).find('.page-content .content-block');
            $('#loading_img').show()
            hnapi.pageContent("/p/" + productID + "?lazyLoad=true", null, null, function (data) {
                $('#loading_img').hide()
                data = JSON.parse(data);
                var compiledTemplate = Template7.compile($$('#ProductDetailsTemplate').html());
                $elem.html(compiledTemplate(data));

                if (planIDCountInChart.sunccess == null) {
                    planIDCountInChart.forEach(function (object, index) {
                       // $('.ProductDetails[data-planid="' + object.planID + '"] .priceWrapper').addClass('active').find('.fsCounter').html(object.ProductCount)

                    })
                }
                if (data.AmazingPrice > 0)
                    AmazingofferContentLoad($elem)

            });

        }

        else if (page.name == "ProductListM") {
            var productID = getURLParameter(page.url, "id");


            ah7App.showTab('#mainView');

            var $elem = $$(page.container).find('.page-content .content-block');
            $('#loading_img').show()
            hnapi.pageContent("/Site/ProductList?menuID=" + productID + "&lazyLoad=true", null, null, function (data) {
                $('#loading_img').hide()

                var compiledTemplate = Template7.compile($$('#ProductListMTemplate').html());
                $elem.html(compiledTemplate(JSON.parse(data)));



            });

        }
        else if (page.name == "MenuList") {
            var menuListRepository = JSON.parse(window.localStorage.getItem('MenuListRepository'));
            var menuID = getURLParameter(page.url, "id");
            var $elem = $$(page.container).find('.page-content');

           
            if (menuListWrapperClone != null) {
                menuListWrapperClone.appendTo($elem)
                rebuildMenuList(menuID)

               
            }
            else {
                generateBoxTemplate("MenuList", menuListRepository, $elem, menuID)

                $('.swiper-slide.foodMenu li').removeClass('active')

                if (planIDCountInChart.sunccess == null) {
                    planIDCountInChart.forEach(function (object, index) {
                        $('.swiper-slide.foodMenu li[data-planid="' + object.PlanID + '"]').addClass('active').find('.fsCounter').html(object.ProductCount)
                    })
                }
                menuListWrapperClone = $('.menuListWrapper').clone()
            }
          
        }
        else if (page.name == "ChangePassword") {
            EachAjaxForm();
        }
        //else if (page.name == "register") {

        //    $('input[name="Email"]').attr('data-sendverificationcode', Template7.global.SendEmailVerificationLink)
        //    $('input[name="PhoneNumber"]').attr('data-sendverificationcode', Template7.global.SendPhoneVerificationCode)
        //    if (Template7.global.SendPhoneVerificationCode)
        //        $('input[name="PhoneNumber"]').addClass('isUnique')

        //    $('#register-container').show()
        //    EachAjaxForm();
        //}
        else if (page.name == "AddressReview") {
            $$(page.container).find('.page-content').html('<div class="infinite-scroll-preloader"><div class="preloader"></div></div>');

            hnapi.pageContent('/Site/ChartFinalizing', { lazyLoad: true, basketID: basketID, applicationCookieAuth: window.localStorage.getItem('lrCode') }, null, function (data) {

                data = JSON.parse(data);
                if (data.sunccess != false) {
                    $$(page.container).find('.page-content').html('');
                    generateBoxTemplate("AddressReview", data, $$(page.container).find('.page-content'))
                    window.localStorage.setItem('Iran_OstanList', JSON.stringify(data.Iran_Ostan));
                }
                else {
                    app.alert(data.message, '')
                    setTimeout(function () {
                        
                        bascketView.router.reloadPage("index.html")
 
                          //  setChartData();
                    }, 500)

                }
                if (data.UserAddressList!=null && data.UserAddressList.length == 0) {

                    $('a[href="chartFinalizing.html"]').hide();
                }

            })

        }
        else if (page.name == "chartFinalizing") {
            selectedUserAddressID = $('input[name=rdUserAddress]:checked').val();
            $$(page.container).find('.page-content').html('<div class="infinite-scroll-preloader"><div class="preloader"></div></div>');

            hnapi.pageContent('/Site/ChartFinalizing', { lazyLoad: true, basketID: basketID, applicationCookieAuth: window.localStorage.getItem('lrCode') }, null, function (data) {

                data = JSON.parse(data);
                if (data.sunccess != false) {
                    $$(page.container).find('.page-content').html('');
                    generateBoxTemplate("chartFinalizing", data, $$(page.container).find('.page-content'))

                }
                else {
                    app.alert(data.message, '')
                    setTimeout(function () {
                        bascketView.router.load({ pageName: 'index' });

                    }, 500)

                }

            })

        }

        else if (page.name == "AddAddress") {
            var iran_OstanList = JSON.parse(window.localStorage.getItem('Iran_OstanList'));

            iran_OstanList.forEach(function (object, index) {
                $$(page.container).find('#ostans').append('<option value="' + object.OstanID + '">' + object.Ostan + '</option>')
            })

            EachAjaxForm();
            initializeMapFirst();
        }
        else if (page.name == "OrderReview") {
          //  if (selectedUserAddressID == null)
                selectedUserAddressID = $('input[name=rdUserAddress]:checked').val();
            selectedPostID = $('input[name=rdpost]:checked').val();
            $('#loading_img').show()
            hnapi.pageContent('/Site/OrderReview', {
                lazyLoad: true,
                basketID: basketID,
                applicationCookieAuth: window.localStorage.getItem('lrCode'),
                userAddressID: selectedUserAddressID,
                postTemplateID: selectedPostID
            }, null, function (data) {
                $('#loading_img').hide()
                data = JSON.parse(data);
                generateBoxTemplate("OrderReview", data, $$(page.container).find('.page-content'))

            })
        }
        else if (page.name == "PaymentReview") {
            $('#loading_img').show()
            hnapi.pageContent('/Site/PaymentReview', {
                lazyLoad: true,
                basketID: basketID,
                applicationCookieAuth: window.localStorage.getItem('lrCode'),
                userAddressID: selectedUserAddressID,
                postTemplateID: selectedPostID
            }, null, function (data) {
                $('#loading_img').hide()
                data = JSON.parse(data);
                generateBoxTemplate("PaymentReview", data, $$(page.container).find('.page-content'))

            })
        }
    });
    ah7App.onPageAfterAnimation('newsText', function (page) {
        var newsID = getURLParameter(page.url, "id");
        $('#loading_img').show()
        hnapi.pageContent("/Home/NewsText?newsID=" + newsID, null, null, function (data) {
            $('#loading_img').hide()
            $('.page[data-page="newsText"] .newsText').html(data)
        })
        $('.page[data-page="newsText"] .preloader').remove();
    });

    window.setMenuList = function setMenuList() {

        if (window.localStorage.getItem('lrCode') != null)
            $$('.panel.panel-right.panel-reveal .content-block-title a').html(window.localStorage.getItem('fullName'))
        else
            $$('.panel.panel-right.panel-reveal .content-block-title a').html('ثبت نام | ورود')

        hnapi.pageContent("/home/GetMenuList", null, null, function (data) {

            data = JSON.parse(data);
            generateBoxTemplate("menu", data, '.panel.panel-right.panel-reveal .menu-list')

        })


    }
    $('.btnProductMenuView').click(function () {
        $('#loading_img').show()
        hnapi.pageContent("/home/GetMenuList?pageMenu=false", null, null, function (data) {
            $('#loading_img').hide()
            data = JSON.parse(data);
            $('div#ProductMenuView .content-block').html('')
            generateBoxTemplate("productMenu", data, 'div#ProductMenuView .content-block')

        })


        //bascketView.destroy()
    })


    // Fetch Stories
    window.getPageContent = function getPageContent(menuID, refresh, pageName) {
        if (menuID == null)
            menuID = -1;

        var results = refresh ? [] : JSON.parse(window.localStorage.getItem('pageContent' + menuID));

        if (pageName == null)
            pageName = "index";
        pageName = ".page[data-page='" + pageName + "'] ";
        if (results == null || results.length === 0) {
            if (!refresh) {
                ah7App.showPreloader('در حال بارگزاری : <span class="preloader-progress">0</span> %');
            }

            hnapi.pageContent("/PageManager/GetDynamicPageContent?fromMobile=true&menuID=" + menuID + "&isProfileMenu=true&applicationCookieAuth=" + window.localStorage.getItem('lrCode'), null, null, function (data) {
                data = JSON.parse(data);
                //window.localStorage.setItem('pageContent' + menuID, JSON.stringify(data));
                if (data.length == 0)
                    ah7App.hidePreloader();

               

                updatePageContent(data, menuID, pageName, refresh);

               

            });
        }
        else {
            // Update T7 data and render home page stories
            updatePageContent(results, menuID, pageName, refresh);
        }

        return results;
    }



    //function CalculateDate() {
    //    moment("20111031", "YYYYMMDD").fromNow();
    //}

    function extend(target) {
        var sources = [].slice.call(arguments, 1);
        sources.forEach(function (source) {
            for (var prop in source) {
                target[prop] = source[prop];
            }
        });
        return target;
    }
    function updatePageContent(data, menuID, pageName, refresh) {
        data = JSON.parse(data);


        var counter = 0, storiesCount = 0;
        $$(pageName + '.page-content[data-menuid="' + menuID + '"] .mainPageContent').html('')
        if (data.madules.length == 0) {
            $('#loading_img').hide()

         
            ah7App.hidePreloader();

        }
        else {
            data.madules.forEach(function (object, index) {
                var url = "";
                var tempData = null;
                var tmplname = object.BoxGroupName;
                switch (tmplname) {

                    //case "GoogleMap":
                    //    tempData = { Title: object.BoxTitle, Content: '<iframe src="' + Template7.global.websiteRoot + '/PageManager/GoogleMap?boxID=' + object.BoxID + '" style="height: 100%; width: 100%;     border: none;"></div>' };
                    //    tmplname = "iFrame";
                    //    break;
                    //case "content":
                    //    tempData = { Title: object.BoxTitle, Content: object.Content };
                    //    break;
                    //case "singleImage":
                    //    if (object.BoxStyle == "fixed")
                    //    tempData = { Title: object.BoxTitle, Content: '<div class="singlePage ' + object.BoxStyle + '">' + (object.BoxTitle != null ? '<div class="singleImgTitle"><h2>' + object.BoxTitle + '</h2><p>' + object.ShowMoreLink + '</p></div>' : '') + '<img src="' + Template7.global.websiteRoot + '/Content/images/' + Template7.global.websiteID + '/PageImage/' + object.MediaID + '.jpg" >   </div>' };
                    //    tmplname = "empty";
                    //    break;

                    case "ContainerTabs":
                        //if (containerTabs != null && containerTabs != '') {

                        //    var tabCount = containerTabs.length + 1;
                        //    var containerTabTitleModel = [];
                        //    $.each(containerTabs, function (i, el) {
                        //        containerTabTitleModel.push({
                        //            tabID: el.TabID,
                        //            tabTitle: el.Title,
                        //            tabCount: tabCount,
                        //            BoxIDList: el.BoxIDList
                        //        });
                        //        $.each(el.BoxIDList.split('.'), function (j, containsBoxID) {

                        //            if (containsBoxID.trim() != '') {
                        //                LogIDListvisibleForTab.push({ boxID: boxID, containsBoxID: containsBoxID })
                        //            }
                        //        })
                        //    })


                        //}
                        //repository = $("#ContainerTabs-temp").tmpl({
                        //    tabs: containerTabTitleModel
                        //}).html();
                        break;

                }
                if (tmplname != "HtmlCode") {
                    //var hasLoadding = url == "" || url == null ? false : true;
                    //url.indexOf('?') == -1 ? url += "?" : url += "&";
                    //url += 'boxID=' + object.BoxID + "&boxCount=" + object.BoxCount;
                    var repository = '';
                    var dateTime = new Date();
                    var ticks = dateTime.getTime();
                    var extraData = { boxID: object.BoxID, BoxTitle: object.BoxTitle, FormID: object.FormID, Ticks: ticks };

                    var model = getObjects(data.jsonContentList, "BoxID", object.BoxID)
                    if (object.BoxGroupName != "content")
                        model = model.Content

                    var object3 = extend({}, extraData, model);

                    generateBoxTemplate("boxWrapper", { boxID: object.BoxID, BoxTitle: object.BoxTitle, tmplname: object.BoxGroupName, boxStyle: object.BoxStyle }, pageName + '.page-content[data-menuid="' + menuID + '"] .mainPageContent')
                    generateBoxTemplate(object.BoxGroupName, object3, pageName + '#box' + object.BoxID)
                  
                    if (object.BoxGroupName == "news") {
                        window.localStorage.setItem('newsRepository', JSON.stringify(object3.model.News));
                        $('#box' + object.BoxID).parent().parent().addClass('infinite-scroll').append('  <div class="infinite-scroll-preloader"><div class="preloader"></div></div>')
                        var $pageContent = $('#box' + object.BoxID).parent().parent();

                        $pageContent.data('boxID', object.BoxID)
                        $pageContent.data('count', object3.newsCount)
                        $pageContent.data('loading', false)
                        $pageContent.data('rowName', '.blog-post-wrapper')
                        ah7App.attachInfiniteScroll($pageContent)
                    }
                    else if (object.BoxGroupName == "product1") {
                        if (object.BoxStyle == "food") {
                            // console.log(object3)
                            window.localStorage.setItem('MenuListRepository', JSON.stringify(object3));
                        }
                        else {
                            //  window.localStorage.setItem('ProductListRepository', JSON.stringify(object3.productSlide));
                        }
                    }
                    else if (object.BoxGroupName == "ProductListM") {
                        // GetDataDynamicFrom(object3);
                    }
                    else if (object.BoxGroupName == "form") {
                        GetDataDynamicFrom(object3);
                    }

                    //if (hasLoadding) {
                    //    hnapi.pageContent(url, null, null, function (urlData, j) {
                    //        var dateTime = new Date();
                    //        var ticks = dateTime.getTime();
                    //        var extraData = { BoxTitle: object.BoxTitle, FormID: object.FormID, Ticks: ticks };
                    //        var object3 = extend({}, extraData, JSON.parse(urlData));
                    //        //Template7.global

                    //        generateBoxTemplate(object.BoxGroupName, object3, pageName + '#box' + object.BoxID)

                    //        if (object.BoxGroupName == "news") {
                    //            window.localStorage.setItem('newsRepository', JSON.stringify(object3.model.News));
                    //            $('#box' + object.BoxID).parent().parent().addClass('infinite-scroll').append('  <div class="infinite-scroll-preloader"><div class="preloader"></div></div>')
                    //            var $pageContent = $('#box' + object.BoxID).parent().parent();

                    //            $pageContent.data('boxID', object.BoxID)
                    //            $pageContent.data('count', object3.newsCount)
                    //            $pageContent.data('loading', false)
                    //            $pageContent.data('rowName', '.blog-post-wrapper')
                    //            ah7App.attachInfiniteScroll($pageContent)
                    //        }
                    //        else if (object.BoxGroupName == "product1") {
                    //            if (object.BoxStyle == "food") {
                    //                window.localStorage.setItem('MenuListRepository', JSON.stringify(object3));
                    //            }
                    //        }
                    //        else if (object.BoxGroupName == "form") {
                    //            GetDataDynamicFrom(object3);
                    //        }
                    //    })

                    //    tmplname = "boxWrapper"
                    //    tempData = { boxID: object.BoxID, height: object.Height, BoxTitle: object.BoxTitle }
                    //}
                }


                if (tempData != null)
                    results[index] = { tmplname: tmplname, data: tempData };
                counter++;
                storiesCount += 100 / data.madules.length;
                $$('.preloader-progress').text(Math.floor(storiesCount));

                if (counter === data.madules.length) {
                    if (!refresh) {
                        ah7App.hidePreloader();
                        ah7App.hidePreloader();
                        $('#loading_img').hide()
                    }



                    //    ah7App.pullToRefreshDone();
                    // reset .refresh-icon if necessary
                    $$('.refresh-link.refresh-home').removeClass('refreshing');
                    // Clear searchbar
                    //  $$('.searchbar-input input')[0].value = '';
                    // Update T7 data and render home page stories
                    // updatePageContent(results, menuID, pageName);
                }
            });



            if (Template7.global.websiteID == 798 || Template7.global.websiteID == 591)  // nayeb
            {

                if (menuID == -1 && window.localStorage.getItem('MenuListRepository') != null) {
                    var menuListRepository = JSON.parse(window.localStorage.getItem('MenuListRepository'));

                    generateBoxTemplate("MenuList", menuListRepository, $$('.mainPageContent'), null)

                    if (planIDCountInChart.sunccess == null) {
                        planIDCountInChart.forEach(function (object, index) {
                            $('.swiper-slide.foodMenu li[data-planid="' + object.PlanID + '"]').addClass('active').find('.fsCounter').html(object.ProductCount)
                        })
                    }
                    menuListWrapperClone = $('.menuListWrapper').clone()
                    $('.swiper-slide[data-menuid="37709"]').click()
                }

            }


        }

      
       

    }

    function generateBoxTemplate(tmplname, data, $elem, id) {

        var compiledTemplate = Template7.compile($$('#' + tmplname + 'Template').html());
        $$($elem).append(compiledTemplate(data));

        ah7App.swiper('.swiper-1', {
            speed: 400,
            spaceBetween: 20,
            preloadImages: false,
            lazyLoading: true,
            pagination: '.swiper-pagination',
            //paginationHide: false,
            paginationClickable: true,
            //nextButton: '.swiper-button-next',
            //prevButton: '.swiper-button-prev',
            slidesPerView: 1,// slidesPerView: 1.2,
            //direction: 'vertical',
            loop: true,
            onSlideChangeEnd: function (s) {

                var $elem = $(s.container[0]).find('.swiper-pagination > span')

                var bulletActiveClass = "swiper-pagination-bullet-active";
                $elem.removeClass(bulletActiveClass);
                var current = s.activeIndex - 1;
                if (current >= $elem.length)
                    current = 0;
                $elem.eq(current).addClass(bulletActiveClass);
            }
        });
       
      
        $('.productSlide:not(.swiped)').each(function () {
            $(this).addClass('swiped')
            $(this).attr('data-count', '0')
            var maxCount = $(this).find('.swiper-wrapper >a').length
            var $this = $(this)

            var productSlideSwip = ah7App.swiper(this, {
                speed: 400,
                spaceBetween: 15,
                slidesPerView: 2
            });

            $(this).parent().parent().find('.slidesjs-previous').click(function (e) {
                e.preventDefault();
                var count = parseInt($this.attr('data-count'))
                if (count < maxCount) {
                    count += 2;
                    $this.attr('data-count', count)
                    productSlideSwip.slideTo(count, 500, false);
                    $(this).parent().find('.slidesjs-next').removeClass('hide')
                }
                if ((count + 2) >= maxCount) {
                    $(this).addClass('hide')
                }
            });

            $(this).parent().parent().find('.slidesjs-next').click(function (e) {
                e.preventDefault();
                var count = parseInt($this.attr('data-count'))
                if (count > 0) {
                    count -= 2;
                    $this.attr('data-count', count)
                    productSlideSwip.slideTo(count, 500, false);
                    $(this).parent().find('.slidesjs-previous').removeClass('hide')
                }
                if (count <=0 )  {
                    $(this).addClass('hide')
                }
         
            });
        })
       
     


        rebuildMenuList(id);
        if (tmplname == "AmazingOffer")
            AmazingofferContentLoad($($elem));

        $(".zoom").swipebox()
    }
    function rebuildMenuList(id) {
        $('.menuGroupSwiper').each(function () {

            var menuGroupSwiper = ah7App.swiper(this, {
                speed: 400,
                preloadImages: true,
                //lazyLoading: true,
                slidesPerView: 4,
            });

            var menuswiper = new Swiper($(this).parent().find('.menuswiper'), {
                speed: 400,
                preloadImages: true,
                //lazyLoading: true,
                spaceBetween: 20
            });


            $(this).find('.swiper-slide').click(function (e) {
                e.preventDefault();
                menuGroupSwiper.slideTo($(this).index(), 500, false);
                menuswiper.slideTo($(this).index(), 500, false);
                $(this).parent().find('.swiper-slide').removeClass('active');
                $(this).addClass('active');
            });



            //menuswiper.on('slideChangeStart', function () {

            //});

            menuswiper.on('onSlideChangeEnd', function (e) {
                var menuID = e.container.find('.gallery-list').attr('data-menuid');

                var index = menuswiper.activeIndex;
                menuGroupSwiper.slideTo(index, 500, false);
                menuswiper.slideTo(index, 500, false);
                $(".menuGroupSwiper .swiper-slide").removeClass('active');
                $(".menuGroupSwiper .swiper-slide:eq(" + index + ")").addClass('active');

            });


            menuswiper.once('sliderMove', function () {

            });


            var index = $(this).find('.swiper-slide[data-menuid="' + id + '"]').index();
            //menuGroupSwiper.slideTo(index, 500, false);
            //menuswiper.slideTo(index, 500, false);
            //$(this).find('.swiper-slide').removeClass('active');
            var $this = $(this);
            setTimeout(function () {
                $this.find('.swiper-slide[data-menuid="' + id + '"]').click();
            }, 50)


            $('.swiper-slide.foodMenu li .fsCounter').html('0')

            if (planIDCountInChart.sunccess == null) {
                planIDCountInChart.forEach(function (object, index) {
                    $('.swiper-slide.foodMenu li[data-planid="' + object.PlanID + '"]').addClass('active').find('.fsCounter').html(object.ProductCount)
                })
            }
        })

    }
    //$('.toolbar-inner > a:not(.mainPageLink)').click(function () {
    //    $('.toolbar-inner >a').removeClass('active')
    //    $(this).addClass('active')
    //    $('.mainPageLink').removeClass('dataLoadded')
    //})

  
    $$(document).on('click', '.mainPageLink', function (e) {
        //$('#loading_img').show()
        //  if (mainView.activePage.name != "index") {
        //mainView.destroy()
        //mainView = ah7App.addView('#mainView', { dynamicNavbar: true });
        //$('#mainView .pages')
        //    .html('<div class="page" data-page="index"><div class="page-content pull-to-refresh-content" data-menuid="-1"><div class="pull-to-refresh-layer"><div class="preloader"></div><div class="pull-to-refresh-arrow"></div></div><div class="searchbar-overlay"></div><div class="content-block searchbar-not-found">  چیزی برای نمایش یافت نشد </div><div class="mainPageContent"></div></div></div>')

        //getPageContent(-1, false);

        //   }

        //if ($('#mainView div.mainPageContent .content-block').length > 0 && $('#mainView .menuListWrapper').length == 0 && menuListWrapperClone != null) {
        //    menuListWrapperClone.insertAfter('#mainView .page[data-page="MenuList"] .content-block')
        //    rebuildMenuList()
        //}
        if ($('#mainView .page[data-page="index"]').length) {
            mainView.router.load({ pageName: 'index' });
        }
        else {
            $('#loading_img').show()
            mainView.router.loadPage("index.html")
        }
      
        // 
        //$$('#mainView .navbar-inner').html(' <div class="left"><a href="#" class="link icon-only open-panel"> <i class="icon icon-bars"></i></a></div><div class="center sliding" >' + Template7.global.websiteName + '</div>')
    })
    $$(document).on('click', '.menuListLink', function () {
        if ($('#MenuListView div.mainPageContent .content-block').length > 0 && $('#MenuListView .menuListWrapper').length == 0 && menuListWrapperClone != null) {
            menuListWrapperClone.insertAfter('#MenuListView .page[data-page="MenuList"] .content-block')
            rebuildMenuList()
        }
    })

    $$(document).on('click', '.menu-btnBasketView', function () {
        ah7App.showTab('#bascketView');
        bascketView.router.loadPage("index.html")
    })

    $$(document).on('click', '.menu-btnProductMenuView', function () {
        ah7App.showTab('#ProductMenuView');
        $('.btnProductMenuView').click();
    })




    $('#btnSearchText').click(function () {
        $('#loading_img').show()
        hnapi.pageContent('/Site/Search', { text: $('input[name="searchText"]').val(), json: true }, null, function (data) {
            $('#loading_img').hide()
            var compiledTemplate = Template7.compile($$('#searchTemplate').html());
            $('#search_resualt').html(compiledTemplate(JSON.parse(data)));

            //ah7App.swiper('.chartList', {
            //    speed: 400,
            //    //spaceBetween: 100,
            //    preloadImages: false,
            //    lazyLoading: true,
            //    pagination: '.swiper-pagination',
            //    //paginationHide: false,
            //    paginationClickable: true,
            //    //nextButton: '.swiper-button-next',
            //    //prevButton: '.swiper-button-prev',
            //    //slidesPerView: 2,
            //    //direction: 'vertical',
            //    loop: true
            //});


        })

    })
    var firstbtnBasketViewClicked = true;
    $('.btnBasketView').click(function () {
       // bascketView.destroy()
       //  bascketView = ah7App.addView('#bascketView', { dynamicNavbar: true });
        //$('#bascketView .pages').html('<div class="page" data-page="index"><div class="page-content" data-menuid="-1"><div id="chartContent"></div></div></div >')
        //setChartData();


        //$('#loading_img').show()

        bascketView.router.reloadPage("index.html")
        if (firstbtnBasketViewClicked)
            firstbtnBasketViewClicked = false;
        else
            setChartData();
        //bascketView.router.load({ pageName: 'index' });



    })
    function setChartData() {


        $('#bascketView .pages').html('<div class="page" data-page="index"><div class="page-content" data-menuid="-1"><div id="chartContent"></div></div></div >')
        $('#bascketView #chartContent').html('<div class="infinite-scroll-preloader"><div class="preloader"></div></div>');
        hnapi.pageContent('/Site/Chart', { lazyLoad: true, basketID: basketID }, null, function (data) {

            var compiledTemplate = Template7.compile($$('#chartTemplate').html());
            $('#bascketView #chartContent').html(compiledTemplate(JSON.parse(data)));
            $('#bascketView #chartContent').data('loading', false)

          
            var count = 0;
            $.each(JSON.parse(data).OderDetailsList, function (i, el) {
                count += el.ProductCount
            })
           
            $('.toolbar .fa-shopping-basket').attr('data-count', count).find('span').html(count)
            //ah7App.swiper('.chartList', {
            //    speed: 400,
            //    //spaceBetween: 100,
            //    preloadImages: false,
            //    lazyLoading: true,
            //    pagination: '.swiper-pagination',
            //    //paginationHide: false,
            //    paginationClickable: true,
            //    //nextButton: '.swiper-button-next',
            //    //prevButton: '.swiper-button-prev',
            //    //slidesPerView: 2,
            //    //direction: 'vertical',
            //    loop: true
            //});


        })
    }
    //var $touchElem, hDistance,
    //    vDistance,
    //    hDistanceLast,
    //    vDistanceLast,
    //    hDistancePercent,
    //    vSwipe = false,
    //    hSwipe = false,
    //    hSwipMinDistance = 10,
    //    vSwipMinDistance = 50,
    //    startCoords = {},
    //    endCoords = {};
    //$(document).on('touchstart', '.chartList.list-block .item-content', function (event) {
    //    if ($touchElem != null) {
    //        $touchElem.css({
    //            'right': '0'
    //        });
    //        $('.swipLeftRemove').remove();
    //    }
    //    $touchElem = $(this);
    //    vSwipe = false;
    //    $touchElem.before('<span class="swipLeftRemove" style="line-height:' + $touchElem.height() + 'px">حذف</span>')
    //    var endCoords = event.originalEvent.targetTouches[0];


    //    startCoords.pageX = event.originalEvent.targetTouches[0].pageX;
    //    startCoords.pageY = event.originalEvent.targetTouches[0].pageY;


    //    var winWidth = window.innerWidth ? window.innerWidth : $(window).width();
    //    $touchElem.bind('touchmove', function (event) {

    //        endCoords = event.originalEvent.targetTouches[0];

    //        if (!hSwipe) {
    //            vDistanceLast = vDistance;
    //            vDistance = endCoords.pageY - startCoords.pageY;
    //        }

    //        hDistance = endCoords.pageX - startCoords.pageX;
    //        hDistancePercent = hDistance * 100 / winWidth;
    //        if (-hDistancePercent > 2) {
    //            event.preventDefault();
    //            event.stopPropagation();
    //            if (-hDistancePercent > 20)
    //                vSwipe = true;


    //            if (-hDistancePercent > 40) {
    //                hDistancePercent = -40;
    //            }
    //            // swipe left
    //            if (0 < hDistance) {

    //                $touchElem.css({
    //                    'right': -hDistancePercent + '%'
    //                });

    //            }
    //            else if (0 > hDistance) {

    //                $touchElem.css({
    //                    'right': -hDistancePercent + '%'
    //                });

    //            }
    //            return false;
    //        }

    //    });



    //}).bind('touchend', function (event) {
    //    event.preventDefault();
    //    event.stopPropagation();

    //    if ($touchElem != null) {
    //        if (vSwipe) {
    //            $touchElem.css({
    //                'right': '23%'
    //            });

    //        }
    //        else {
    //            $touchElem.css({
    //                'right': '0'
    //            });
    //        }
    //    }

    //});
    //$$(document).on('click', '.swipLeftRemove', function () {
    //    $(this).next().fadeOut().find('.fsCounter').html('0')
    //    removeProductFromChart($(this).next().attr('data-productid'))


    //    calculateChartPrice()
    //})

    function removeProductFromChart(productID) {

        //var cart = $('.toolbar .fa-shopping-basket');

        //hnapi.pageContent('/Site/Chart', { getCount: true, productID: productID, lazyLoad: true, basketID: basketID, removeFromChart: true }, "Post", function (data) {

        //    cart.attr('data-count', data).find('span').html(data)
        //    shake(cart, 5)
        //})
        $('.swipLeftRemove').remove();
    }


    $$(document).on('click', '.btnfinalPayment', function () {
        $('#loading_img').show();
        var dargahID = $('input[name=rdDargahBank]:checked').val();
        var paymentKindSelected = $('input[name=paymentKindSelected]:checked').val();
        var link = "/Site/Payment?lazyLoad=true&basketID=" + basketID
            + "&userAddressID=" + selectedUserAddressID + "&postTemplateID=" + selectedPostID + "&dargahID=" + dargahID + "&paymentKindID=" + paymentKindSelected +
            "&discountCode=" + $('input[name="DiscountCode"]').val() +
            "&PeymentDate=" + $('input[name="PeymentDate"]').val() +
            "&PeymentTime=" + $('input[name="PeymentTime"]').val() +
            "&creditAmount=" + $('#creditAmount').val();

        $('.toolbar .fa-shopping-basket').attr('data-count', 0).find('span').html(0)
       // window.localStorage.removeItem('BasketID')
        planIDCountInChart = [];
       // basketID = null;

        if (paymentKindSelected == "1") {
            link = Template7.global.websiteRoot + link + "&applicationCookieAuth=" + window.localStorage.getItem('lrCode')

            window.open(link, '_system');
            
            //ah7App.showTab('#mainView');
            //$('.mainPageLink').click()
          
        }
        else {
          
            hnapi.pageContent(link, { applicationCookieAuth: window.localStorage.getItem('lrCode') }, null)

        
        }
        bascketView.router.reloadPage("PaymentManager.html")
        $('#loading_img').hide();

    })
    $(document).on('change', '.time-wrapper .timeAmPm', function () {
        var $timeWrapper = $(this).parent().parent();
        $timeWrapper.find('input[type="hidden"]').val($timeWrapper.find('.txtTime_H').val() + ":" + $timeWrapper.find('.txtTime_M').val() + ":" + $timeWrapper.find('.timeAmPm option:selected').val());
    })
    $(document).on('change', '.time-wrapper .txtTime_H, .time-wrapper .txtTime_M', function () {
        var $timeWrapper = $(this).parent().parent();
        $timeWrapper.find('input[type="hidden"]').val($timeWrapper.find('.txtTime_H').val() + ":" + $timeWrapper.find('.txtTime_M').val() + ":" + $timeWrapper.find('.timeAmPm option:selected').val());
    })
    $(document).on('change', '.date-wrapper .date_day , .date-wrapper .date_mounth , .date-wrapper .date_year', function () {
        var $dateWrapper = $(this).parent().parent();
        $dateWrapper.find('input[type="hidden"]').val($dateWrapper.find('.date_year option:selected').val() + "/" + $dateWrapper.find('.date_mounth option:selected').val() + "/" + $dateWrapper.find('.date_day option:selected').val());
    })

    $(document).on('blur', '#CreditPrice', function () {
        $('input[name="CreditPriceValue"]').val($(this).val())
    });

    $$(document).on('click', '.btnCreditPayment', function () {
        $('#loading_img').show();

        var creditPrice = $('input[name="CreditPriceValue"]').val();

        var link = "/Site/PayForCreditPackage?price=" + creditPrice ;
        link = Template7.global.websiteRoot + link + "&applicationCookieAuth=" + window.localStorage.getItem('lrCode')

        window.open(link, '_system');
        $('#loading_img').hide();

    })


    $$(document).on('click', '.btnOnlinePaymentAgain', function () {

        var link = Template7.global.websiteRoot + "/Site/PaymentAgain?transactionID=" + $(this).attr('data-tid') + "&applicationCookieAuth=" + window.localStorage.getItem('lrCode');
        window.open(link, '_system');

    });

    var popupView = null;


    $$(document).on('click', '.btnShowFactor', function () {


        $('#loading_img').show();
        var link = Template7.global.websiteRoot + "/SuperAdmin/ImgFactor?orderID=" + $(this).attr('data-oid') + "&applicationCookieAuth=" + window.localStorage.getItem('lrCode');

        if (popupView === null) {
            popupView = ah7App.addView('.popup-view');
        }

        ah7App.popup('.popup-view');
        $('.popup .left.sliding').html('فاکتور')
        $('.popup .page-content').html("<iframe src=" + link + "></iframe>")
        $('#loading_img').hide();


    });


    var btnnuserOrdersClicked = false;
    $$(document).on('click', '.btnuserProfuleView', function () {

        ah7App.showTab('#profileView');

        if ($(this).hasClass('btnuserOrders'))
            btnnuserOrdersClicked = true;
        else
            btnnuserOrdersClicked = false;

       

        if ($('#profileView.active #ProfileInfoTemplate_wrapper').length) {

            if (!btnnuserOrdersClicked) {
                $('#wrapper_userInfo').show()
                $('#wrapper_userorderList').hide()
            }
            else {
                $('#wrapper_userInfo').hide()
                $('#wrapper_userorderList').show()
            }
        }
        else {
            if (window.localStorage.getItem('lrCode') == null) {
                $('#login_wrapper').show()
                $('#profile_wrapper').hide()
                Food_userAuthentication()
            }
            //else if (window.localStorage.getItem('VerifyPhoneNumber') == null) {

            //    $('#login_wrapper, #register-container, #profile_wrapper, #phoneNumberVerification').hide()
            //    $('#AddPhoneNumber_Wrapper').show()
            //}
            else {
                setProfileInfo()
            }

        }
        $('#profileView input[name="PhoneNumber"]').focus()
       
    })
    $$(document).on('click', '.btnEditUserInfo', function () {


        if (popupView === null) {
            popupView = ah7App.addView('.popup-view');
        }

        ah7App.popup('.popup-view');
        $('.popup .left.sliding').html('ویرایش اطلاعات')
        $('.popup .page-content').html($('#userInfo_wrapper_data').html())

        EachAjaxForm();

    })

    $$(document).on('click', '.btnBuyUserCredit', function () {

        if (popupView === null) {
            popupView = ah7App.addView('.popup-view');
        }

        ah7App.popup('.popup-view');
        $('.popup .left.sliding').html('افزایش اعتبار')
        $('.popup .page-content').html($('#userCredit_wrapper_data').html())

        EachAjaxForm();

    })

    window.afterClinetInfoEdit = function afterClinetInfoEdit() {
        setProfileInfo()

    }


    function setProfileInfo() {

        $('#login_wrapper').hide()
        $('#profile_wrapper').show()

        $('#loading_img').show()
        hnapi.pageContent("/Manage/Index?lazyLoad=true" + "&applicationCookieAuth=" + window.localStorage.getItem('lrCode'), null, null, function (data) {
            $('#loading_img').hide()
            if (data.message != null) {
                $('#login_wrapper').hide()
                $('#AddPhoneNumber_Wrapper').show()
            }
            else {
                window.localStorage.setItem('VerifyPhoneNumber', 'true');
                var compiledTemplate = Template7.compile($$('#ProfileInfoTemplate').html());
                $('#profile_wrapper').html(compiledTemplate(JSON.parse(data)));
            }

            if (!btnnuserOrdersClicked) {
                $('#wrapper_userInfo').show()
                $('#wrapper_userorderList').hide()
            }
            else {
                $('#wrapper_userInfo').hide()
                $('#wrapper_userorderList').show()
            }
        });
    }
    //$('.btnRegister').click(function () {
    //    $('input[name="Email"]').attr('data-sendverificationcode', Template7.global.SendEmailVerificationLink)
    //    $('input[name="PhoneNumber"]').attr('data-sendverificationcode', Template7.global.SendPhoneVerificationCode)
    //    if (Template7.global.SendPhoneVerificationCode)
    //        $('input[name="PhoneNumber"]').addClass('isUnique')
    //    $('#register-container').show()
    //    $('#profile_wrapper, #login_wrapper, #phoneNumberVerification, #AddPhoneNumber_Wrapper').hide()
    //})
    //$('.btnLogin').click(function () {
    //    $('#login_wrapper').show()
    //    $('#profile_wrapper').hide()
    //})

    $$(document).on('click', '#btnLogoff', function () {
        // window.localStorage.clear();
        window.localStorage.removeItem('lrCode')
        window.localStorage.removeItem('fullName')
        window.localStorage.removeItem('VerifyPhoneNumber')
        window.localStorage.removeItem('BasketID')
        $$('.panel.panel-right.panel-reveal .content-block-title a').html('ثبت نام | ورود')
        menuListWrapperClone = null;
        planIDCountInChart = [];
        basketID = null;
        $('.toolbar .fa-shopping-basket').attr('data-count', 0).find('span').html(0)

        $('#profile_wrapper').hide()
        $('#login_wrapper').show()
        Food_userAuthentication()
    })
    $$(document).on('click', '#btnChangePass', function () {
        $('#ChangePassword_Wrapper').show()
        $('#ProfileInfoTemplate_wrapper').hide()
    })



    $$(document).on('click', '.submitChart', function () {
        var a = window.localStorage.getItem('lrCode');
        if (window.localStorage.getItem('lrCode') == null) {
            ah7App.showTab('#profileView');
            resaultLoginPage = "submitChart";

            $('#profile_wrapper').hide()
            $('#login_wrapper').show()
            Food_userAuthentication()
        }
        else {
            if (Template7.global.websiteID == "1123")
                bascketView.router.reloadPage('OrderReview.html');
            else
                bascketView.router.reloadPage("AddressReview.html");
          //  bascketView.loadPage('AddressReview.html')
           
        }
    })


    window.addAddressSuccess = function addAddressSuccess($form, data) {
        $('#bascketView .pages .page-content[data-page="AddAddress"]').remove()
       
        bascketView.router.reloadPage("AddressReview.html")
    }




    var position = "";
    var marker;
    var google_map;
    var baseLat = 35.7054169035294;
    var baselng = 51.3746050838381;
    var initLat = baseLat;
    var initLng = baselng;
    var initZoom = 12;
    function initializeMapFirst() {


        if (position != null && position != "") {
            initLat = position.split(',')[0];
            initLng = position.split(',')[1];
            initZoom = parseInt(position.split(',')[2]);
            initializeMap()
        }
        else {

            //initializeMap()
            currentLocation()
            //try {





            //var div = document.getElementById("map");

            //var map = window.plugins.google.maps.Map.getMap(div);

            //map.one(plugin.google.maps.event.MAP_READY, function () {

            //    var onSuccess = function (location) {

            //        initLat = location.latLng.lat;
            //        initLng = location.latLng.lng;
            //        initZoom = 13;
            //        initializeMap()
            //    };

            //    var onError = function (msg) {
            //        console.log(JSON.stringify(msg))
            //        initializeMap()
            //    };

            //    var button = div.getElementsByTagName('button')[0];
            //    button.addEventListener('click', function () {
            //        map.clear();
            //        map.getMyLocation(onSuccess, onError);

            //    });

            //});
            //}
            //catch (err) {
            //    alert(err.message)
            //}



        }
    }

    function currentLocation() {
        navigator.geolocation.getCurrentPosition(onSuccess, onError, { maximumAge: 3000, timeout: 5000, enableHighAccuracy: true });
        function onSuccess(position) {
            initLat = position.coords.latitude;
            initLng = position.coords.longitude;
            initZoom = 13;
            if (google_map == null)
                initializeMap()
            else {
                var latlng = new google.maps.LatLng(initLat, initLng);
                marker.setPosition(latlng);
                google_map.setCenter(latlng);
                google_map.setZoom(13);
                SetGoogleMapPosition(initLat, initLng, initZoom)
            }


        }
        function onError(error) {

            initializeMap()
            //alert('code: ' + error.code + '\n' +
            //    'message: ' + error.message + '\n');
        }
        google.maps.event.addDomListener(window, 'load', onSuccess);

    }

    $$(document).on('click', '#currentLocation', function () {
        currentLocation()
    })

    function initializeMap() {


        SetGoogleMapPosition(initLat, initLng, initZoom)


        var latlng = new google.maps.LatLng(initLat, initLng);
        var myOptions = {
            scrollwheel: true,
            zoom: initZoom,
            gestureHandling: 'greedy',
            center: latlng,
            mapTypeId: google.maps.MapTypeId.ROADMAP
        }; // disableDoubleClickZoom: true
        google_map = new google.maps.Map(document.getElementById("map"), myOptions);


        if (initLat != baseLat && initLng != baselng) {
            marker = new google.maps.Marker({ position: latlng, map: google_map, animation: google.maps.Animation.BOUNCE, draggable: true });
            google.maps.event.addListener(marker, 'dragend', function (event) {
                SetGoogleMapPosition(event.latLng.lat(), event.latLng.lng(), google_map.getZoom())
            });
        }
        else
            marker = new google.maps.Marker({ position: latlng, map: google_map, animation: google.maps.Animation.BOUNCE, draggable: true });
        var gmap_address_search = document.getElementById('gmap_address_search');
        var acInputs = document.getElementById("address-text");
        var currentLocation = document.getElementById('currentLocation');

        google_map.controls[google.maps.ControlPosition.TOP_RIGHT].push(gmap_address_search);
        google_map.controls[google.maps.ControlPosition.BOTTOM_LEFT].push(currentLocation);
        var autocomplete = new google.maps.places.Autocomplete(acInputs);
        $$('body').on('touchend', '.pac-container', function (e) { e.stopImmediatePropagation(); })
        autocomplete.bindTo('bounds', google_map);

        autocomplete.addListener('place_changed', function () {
            marker.setVisible(false);
            var place = autocomplete.getPlace();
            if (!place.geometry) {
                // User entered the name of a Place that was not suggested and
                // pressed the Enter key, or the Place Details request failed.
                window.alert("آدرس با اطلاعات جستجو شده یافت نشد.");
                return;
            }

            // If the place has a geometry, then present it on a map.
            if (place.geometry.viewport) {
                google_map.fitBounds(place.geometry.viewport);
            } else {
                google_map.setCenter(place.geometry.location);
                google_map.setZoom(17);  // Why 17? Because it looks good.
            }
            marker.setPosition(place.geometry.location);
            marker.setVisible(true);

            var address = '';
            if (place.address_components) {
                address = [
                    (place.address_components[0] && place.address_components[0].short_name || ''),
                    (place.address_components[1] && place.address_components[1].short_name || ''),
                    (place.address_components[2] && place.address_components[2].short_name || '')
                ].join(' ');
            }

        });




        google_map.addListener('zoom_changed', function () {
            SetGoogleMapPosition(marker.position.lat(), marker.position.lng(), google_map.getZoom())
        });




        google.maps.event.addListener(google_map, "click", function (e) { //dblclick
            if (marker == null) {
                marker = new google.maps.Marker({ position: e.latLng, map: google_map, animation: google.maps.Animation.BOUNCE, draggable: true });
                google.maps.event.addListener(marker, 'dragend', function (event) {
                    SetGoogleMapPosition(event.latLng.lat(), event.latLng.lng(), google_map.getZoom())
                });
            }
            else
                marker.setPosition(e.latLng);
            SetGoogleMapPosition(e.latLng.lat(), e.latLng.lng(), google_map.getZoom())

        });


    }

    function SetGoogleMapPosition(lat, lng, zoom) {
        if (lat != baseLat) {
            $('input[name="MapPosition"]').val(lat + "," + lng + "," + zoom);

            var $thisPrice = $('#GmapPostPrice span')
            var $thisBranchName = $('#GmapBranch span:first')
            var $thisBranchDescription = $('#GmapBranch div span')
            $thisPrice.html('در حال بررسی...')

            hnapi.pageContent('Site/CheckPosition', { lat: lat, lng: lng }, "Post", function (data) {
                data = JSON.parse(data)
                $thisPrice.html(data.cost)
                $thisBranchName.html(data.branchName)
                $thisBranchDescription.html(data.branchDescription)
            })

        }



    }














    function calculateChartPrice() {
        var totalPrice = 0;
        $('.chartList .fsCounter').each(function () {
            var price = $(this).attr('data-price')
            var discount = $(this).attr('data-discount');
            var count = $(this).html()
            totalPrice += (price - (price * discount / 100)) * count
        })
        if (totalPrice == 0)
            $('.submitChart').hide();
        else
            $('.submitChart').show();
        $('#chartTotalPrice').html(setPriceCama(totalPrice) + " تومان")
    }

    function checkProductInChart(planID, fsCounter) {
        if (planIDCountInChart.sunccess != null && !planIDCountInChart.sunccess) {
            //app.alert(planIDCountInChart.message, '')
            return 
        }

        var productInChart = getObjects(planIDCountInChart, "PlanID", parseInt(planID))
        if (productInChart != "") {
            if (fsCounter == null)
                productInChart.ProductCount += 1;
            else if (fsCounter == 0)
                planIDCountInChart = RemoveObjects(planIDCountInChart, "PlanID", parseInt(planID))
            else
                productInChart.ProductCount = fsCounter == null ? 1 : fsCounter;
        }
        else
            planIDCountInChart.push({ PlanID: parseInt(planID), ProductCount: fsCounter == null ? 1 : fsCounter })

        var count = 0;
        $.each(planIDCountInChart, function (i, el) {
            count += el.ProductCount
        })

        var cart = $('.toolbar .fa-shopping-basket');
        cart.attr('data-count', count).find('span').html(count)
        shake(cart, 5)
    }

    $$(document).on('click', '#btnAddToChart', function () {
      
        var planID = $('input[type=hidden][id^=plan][data-selected=selected]').attr('id').substring(4);
        // var productID = $(this).parent().attr('data-productid')
        checkProductInChart(planID, null)

        $('#loading_img').show()


        hnapi.pageContent('/Site/AddProductToChart', { planID: planID, basketID: basketID, json: true }, "Post", function (data) {
            $('#loading_img').hide()

            if(ShoppingStatusManager(data))
            $$(document).find('.btnBasketView').click()
        })

    })

    $$(document).on('click', '.Product_PlanList > div', function () {
      
        var productID = $(this).parent().parent().attr('data-productid')
        var planid = $(this).attr('data-id')
        checkProductInChart(planid, null)

        hnapi.pageContent('/Site/AddProductToChart', { planID: planid, basketID: basketID, json: true }, "Post", function (data) {
            ShoppingStatusManager(data)
        })

        var cart = $('.toolbar-inner .fa-shopping-basket');
        var imgtodrag = $(this) //.parent().find('img').eq(0);
        if (imgtodrag) {
            var imgclone = imgtodrag.clone().offset({
                top: imgtodrag.offset().top,
                left: imgtodrag.offset().left
            }).css({
                'opacity': '0.5',
                'position': 'absolute',
                //'height': '150px',
                //'width': '150px',
                'z-index': '100'
                }).appendTo($('.swiper-container.menuswiper .swiper-slide')).animate({
                'top': cart.offset().top + 10,
                'left': cart.offset().left + 10,
                //'width': 75,
                //'height': 75
            }, 1000, 'swing');
            setTimeout(function () {
               
                // cart.effect('shake', { times: 2 }, 200);
            }, 1500);
            imgclone.animate({
                'width': 0,
                'height': 0
            }, function () {
                $(this).detach();
            });
        }
    })

    $$(document).on('click', '.btnFoodOrder .fa-plus', function () {
        var fsCounter = parseInt($(this).parent().find('.fsCounter').html()) + 1
        var productID = $(this).parent().attr('data-productid')
        var planid = $(this).parent().attr('data-planid')
        checkProductInChart(planid, fsCounter)

        $('.btnFoodOrder[data-planid="' + planid + '"]').find('.fsCounter').html(fsCounter)
        menuListWrapperClone = $('.menuListWrapper').clone()
        if (ah7App.getCurrentView().selector == "#bascketView")
            calculateChartPrice()

        if (fsCounter == 1) {
            hnapi.pageContent('/Site/AddProductToChart', { planID: planid, basketID: basketID, json: true }, "Post", function (data) {
                ShoppingStatusManager(data)
            })
        }
        else
        hnapi.pageContent('/Site/ChangeProcutCountInChart', { planID: planid, ProductCount: fsCounter, basketID: basketID, json: true }, "Post")

    })
    $$(document).on('click', '.content-block[data-tmplname="slideshow"] div[data-swiper-slide-index="0"]', function () {
        $('.page-content').animate({
            scrollTop: $('.menuListWrapper').offset().top - 60
        }, 300); 
        $('.swiper-slide[data-menuid="37709"]').click()
    })
    $$(document).on('click', '.btnFoodOrder .fa-minus', function () {
        var fsCounter = parseInt($(this).parent().find('.fsCounter').html()) - 1
        var productID = $(this).parent().attr('data-productid')
        var planid = $(this).parent().attr('data-planid')
      
        if (fsCounter >= 0)
            hnapi.pageContent('/Site/ChangeProcutCountInChart', { planID: planid, ProductCount: fsCounter, basketID: basketID, json: true }, "Post")

        if (fsCounter < 0) 
            fsCounter = 0; 

        
        checkProductInChart(planid, fsCounter)
            $('.btnFoodOrder[data-planid="' + planid + '"]').find('.fsCounter').html(fsCounter)
       
        menuListWrapperClone = $('.menuListWrapper').clone()

        if (ah7App.getCurrentView().selector == "#bascketView")
            calculateChartPrice()

       

        if (fsCounter == 0 && $(this).parents('.foodMenu').length ==0) {
            //
            $('.btnFoodOrder[data-planid="' + planid + '"]').find('.fsCounter').html(1)
            removeProductFromChart(productID)

            if ($(this).parent().parent().parent().hasClass('active'))
                $(this).parent().parent().parent().removeClass('active')
            else {
                //$('.foodMenu li[data-productid="' + productID + '"]').removeClass('active')
                $('.btnFoodOrder[data-productid="' + productID + '"]').parent().parent().removeClass('active')
                menuListWrapperClone = $('.menuListWrapper').clone()
                $(this).parent().parent().parent().remove()
            }

        }

 



    })



    function setPriceCama(value) {
        return ("" + parseInt(value)).replace(/\B(?=(\d{3})+(?!\d))/g, ",")
    }
    function SttUrlWithoutSpace(url) {
        return url.replace(/\s+/g, '-').replace(/\./g, '-').replace(/\:/g, '-').replace(/\+/g, '-')
    }
    $$(document).on('click', '.swiper-slide.foodMenu .fa-shopping-basket', function (e) {
        e.preventDefault();
        var $this = $(this)
        var $parent = $this.parent().parent();
        if ($parent.attr('data-productid') == null)
            $parent = $this.parent().parent().parent();

        if ($this.hasClass('notAvailable')) {

            var productID = $parent.attr('data-productid')
            hnapi.pageContent('/Site/checkProductChartStatus', { getCount: true, productID: productID, lazyLoad: true }, "Post", function (data) {

                if (data == "") {
                    $this.addClass('add_to_chartWithOutPlan ').removeClass('add_to_chartDisable')
                    SetShoppingBascket($this, $parent.attr('data-planid'))
                }
                else
                    app.alert(data, '')
            });
        }

        else {
            SetShoppingBascket($this, $parent.attr('data-planid'))
        }

    })

    function SetShoppingBascket($this, planID) {

        $this.parent().parent().addClass('active')

        checkProductInChart(planID, 1)
        menuListWrapperClone = $('.menuListWrapper').clone()

        hnapi.pageContent('/Site/Chart', { getCount: true, planID: planID, lazyLoad: true, basketID: basketID }, "Post", function (data) {

            
            if (!ShoppingStatusManager(data))
                $this.parent().parent().removeClass('active')

        })

    }
    function ShoppingStatusManager(data) {
        data = JSON.parse(data)
        if (data.sunccess != null && !data.sunccess) {
            ah7App.closeNotification(bascketNofication)
            bascketNofication = ah7App.addNotification({
                title: Template7.global.websiteName,
                message: data.message
            });

           
            return false;
        }
        else {


            if (planIDCountInChart.sunccess != null && !planIDCountInChart.sunccess) {
                hnapi.pageContent('/Site/planIDCountInChart?basketID=' + basketID, null, null, function (data) {
                    planIDCountInChart = JSON.parse(data);
                    //if (true) //planIDCountInChart.sunccess == null || planIDCountInChart.message==null)
                    //    shopIsEnable = true;
                    //else
                    //    shopIsEnable = planIDCountInChart.sunccess
                    var count = 0;

                    if (planIDCountInChart.sunccess == "false") {
                        $('.toolbar .fa-shopping-basket span').html(count)
                    }
                    else {
                        $.each(planIDCountInChart, function (i, el) {
                            count += el.ProductCount
                        })
                        $('.toolbar .fa-shopping-basket span').html(count)

                        planIDCountInChart.forEach(function (object, index) {
                            $('.swiper-slide.foodMenu li[data-planid="' + object.PlanID + '"]').addClass('active').find('.fsCounter').html(object.ProductCount)
                        })
                    }
                })
            }


            var count = 0;
            $.each(planIDCountInChart, function (i, el) {
                count += el.ProductCount
            })
            var cart = $('.toolbar .fa-shopping-basket');
            cart.attr('data-count', count).find('span').html(count)
            shake(cart, 5)

            return true
        }
    }

    $$(document).on('click', '.add_to_chartDisable', function (e) {
        $$('.refresh-link.refresh-home').addClass('refreshing');
        $$('.page[data-page="index"] .page-content .mainPageContent').html('')
        var viewName = ah7App.getCurrentView().selector
        var page = document.URL;
        var menuID = getURLParameter(page.url, "id");
        getPageContent(menuID, true);
    });

    //$$(document).on('refresh', '.pull-to-refresh-content', function (e) {
    //    $$('.refresh-link.refresh-home').addClass('refreshing');
    //    $$('.page[data-page="index"] .page-content .mainPageContent').html('')
    //    var viewName = ah7App.getCurrentView().selector
    //    var page = document.URL;
    //    var menuID = getURLParameter(page.url, "id");
    //    getPageContent(menuID, true);
    //});
    $$('.refresh-link.refresh-home').on('click', function () {
        var clicked = $$(this);
        if (clicked.hasClass('refreshing')) {
            return;
        }
        clicked.addClass('refreshing');
        getStories(true);
    });

    $$("body").on("click", ".js-gallery-col", function () {
        var cols = $$(this).data("cols");
        $$(this).parent().parent().next().find(".gallery-list").attr({
            "data-cols": cols
        }), $$(this).parent().find(".js-gallery-col").removeClass("active"), $$(this).addClass("active");
    });

    function getObjects(obj, key, val, key2, val2) {
        var value = '';
        jQuery.map(obj, function (obj) {
            if (obj[key] === val) {
                if (key2 != null) {
                    if (obj[key2] === val2) {
                        value = obj
                    }
                }
                else
                    value = obj;
            }
        })
        return value;
    }

    function RemoveObjects(obj, key, val, key2, val2) {
        var value = '';
        var newObject = [];
        jQuery.map(obj, function (obj) {
            if (obj[key] != val) {
                newObject.push(obj);
            }
        })
        return newObject;
    }

    function getURLParameter(url, name) {
        if (!url) url = location.href;
        name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
        var regexS = "[\\?&]" + name + "=([^&#]*)";
        var regex = new RegExp(regexS);
        var results = regex.exec(url);
        return results == null ? null : results[1];
    }

    function shake($elem, distance) {
        var interval = 100;
        if (distance == null)
            distance = 10;
        var times = 4;

        $elem.css('position', 'relative');

        for (var iter = 0; iter < (times + 1); iter++) {
            $elem.animate({
                left: ((iter % 2 == 0 ? distance : distance * -1))
            }, interval);
        }//for                                                                                                              

        $elem.animate({ left: 0 }, interval);

    }

    function getCurrentDate() {
        var date = new Date();
        var day = date.getDate();        // yields day
        var month = date.getMonth() * 100 / 100 + 1;   // yields month
        var year = date.getFullYear();  // yields year
        var hour = date.getHours();     // yields hours 
        var minute = date.getMinutes(); // yields minutes
        var second = date.getSeconds(); // yields seconds
        // After this construct a string with the above results as below
        var time = padLeft(month, 2) + "/" + padLeft(day, 2) + "/" + year + " " + hour + ':' + padLeft(minute, 2) + ':' + padLeft(second, 2)
        return time;
    }
    function padLeft(nr, n, str) {
        return Array(n - String(nr).length + 1).join(str || '0') + nr;
    }

    $$(document).on('infinite', '.infinite-scroll', function () {

        var maxItems = $(this).data('count')
        var boxID = $(this).data('boxID')
        var loading = $(this).data('loading')
        var lastIndex = $(this).find($(this).data('rowName')).length;
        // Exit, if loading in progress
        if (loading) return;


        $(this).data('loading', true)

        if (lastIndex >= maxItems) {
            ah7App.detachInfiniteScroll($$('.infinite-scroll'));
            $$('.infinite-scroll-preloader').remove();
            return;
        }
        var $this = $(this);

        hnapi.pageContent("/Home/GetNewList?boxID=" + boxID + "&skip=" + lastIndex + "&lazyLoad=true", null, null, function (data) {

            var compiledTemplate = Template7.compile($$('#newsTemplate').html());
            $this.find($this.data('rowName')).parent().append(compiledTemplate(JSON.parse(data)));
            $this.data('loading', false)
        })

    })



    setMenuList();

    window.localStorage.setItem('applicationVersionID', Template7.global.applicationVersionID)
    SetPageContentSyncData();
   // setInterval(SetPageContentSyncData, 15000)


    getPageContent(-1, false);

 

    //window.localStorage.removeItem('lrCode' )
    //window.localStorage.removeItem('BasketID' )

    var newVersionDialog = null;
    function SetPageContentSyncData() {
        
       
        hnapi.pageContent("/PageManager/GetPageSynceStatus", { saveDateTime: window.localStorage.getItem('GetPageSynceStatus'), versionID: window.localStorage.getItem('applicationVersionID') }, null, function (data) {

            data = JSON.parse(data);

            // applicationi version
            if (data.applicationVersions != null && data.applicationVersions.id > window.localStorage.getItem('applicationVersionID')) {
               
                if (newVersionDialog != null) {
                    ah7App.closeModal(newVersionDialog);
                    newVersionDialog = null;
                }
                var ua = navigator.userAgent.toLowerCase();
                var isAndroid = ua.indexOf("android") > -1; //&& ua.indexOf("mobile");
                var downloadUrl = "";
                if (isAndroid)
                {
                    if (data.applicationVersions.AppType == 1) {
                        window.localStorage.setItem('applicationVersionID', data.applicationVersions.id);
                        return;
                    }
                    downloadUrl = Template7.global.websiteRoot + "/home/getapp?anr=true";
                }
                else {
                    if (data.applicationVersions.AppType == 2) {
                        window.localStorage.setItem('applicationVersionID', data.applicationVersions.id);
                        return;
                    }
                    downloadUrl = Template7.global.websiteRoot + "/home/getapp";
                }
                if (data.applicationVersions.Importance == 3) //Necessary
                {
                    setInterval(function () {
                        if ($('.modal.modal-in').length==0)
                        newVersionDialog = ah7App.modal({
                          
                            title: 'ورژن جدید (ضروری)',
                            text: 'نسخه ی جدیدی از برنامه موجود است، با توجه به اهمیت این نسخه لطفا نسخه ی جدید را دانلود و نصب بفرمایید.',
                            buttons: [
                                {
                                    text: 'دانلود',
                                    bold: true,
                                    onClick: function () {
                                        window.location = downloadUrl;
                                    }
                                }
                            ]
                        })
                    }, 3000)
                  
                }
                else if (data.applicationVersions.Importance == 2) //Important
                {
                    newVersionDialog = ah7App.modal({
                        title: 'ورژن جدید' + (data.applicationVersions.Importance == 2 ? "(مهم)" : ""),
                        text: 'نسخه ی جدیدی از برنامه موجود است، مایل به دریافت نسخه جدید هستید؟',
                        buttons: [
                            {
                                text: 'دانلود',
                                bold: true,
                                onClick: function () {
                                    window.location = downloadUrl;
                                }
                            },
                            {
                                text: 'خیر',
                                onClick: function () {
                                    window.localStorage.setItem('applicationVersionID', data.applicationVersions.id);
                                }
                            }
                        ]
                    })
                }
                else if (data.applicationVersions.Importance == 1) //Not Important
                {
                    window.localStorage.setItem('applicationVersionID', data.applicationVersions.id);
                }
              


                // to do
                // importance
                // window.localStorage.setItem('applicationVersionID', data.applicationVersions[0].id);
            }

            var page = document.URL;
            var pageName = '';
            var currentMenuID = getURLParameter(page.url, "id");
            if (currentMenuID == null)
                currentMenuID = -1;

            if (currentMenuID == -1)
                pageName = ".page[data-page='index'] ";
            else
                pageName = ".page[data-page='pageContent'] ";

            //if (data.menuIDList != null) {
            //    data.menuIDList.forEach(function (menuID, index) {
            //        if (window.localStorage.getItem('pageContent' + menuID) != null)
            //            window.localStorage.removeItem('pageContent' + menuID)

            //        hnapi.pageContent("/PageManager/GetDynamicPageContent?fromMobile=true&menuID=" + menuID + "&applicationCookieAuth=" + window.localStorage.getItem('lrCode') , null, null, function (data) {
            //            data = JSON.parse(data);
            //            window.localStorage.setItem('pageContent' + menuID, JSON.stringify(data));

            //            if (menuID == currentMenuID) {
            //                $$(pageName + ' .page-content[data-menuid="' + menuID + '"] .mainPageContent').html('')
            //                updatePageContent(data, menuID, pageName, false);
            //            }

            //        });
            //    })
            //}
          
            //window.localStorage.setItem('GetPageSynceStatus', getCurrentDate());

        })

    }

    if (window.localStorage.getItem('BasketID') == null) {
        hnapi.pageContent('/Site/GetBasketID', null, null, function (data) {
            window.localStorage.setItem('BasketID', data);
            basketID = data;
        })
    }
    else {
        basketID = window.localStorage.getItem('BasketID');
        hnapi.pageContent('/Site/planIDCountInChart?basketID=' + basketID, null, null, function (data) {
            planIDCountInChart = JSON.parse(data);
            //if (true) //planIDCountInChart.sunccess == null || planIDCountInChart.message==null)
            //    shopIsEnable = true;
            //else
            //    shopIsEnable = planIDCountInChart.sunccess

            var count = 0;
            $.each(planIDCountInChart, function (i, el) {
                count += el.ProductCount
            })
            $('.toolbar .fa-shopping-basket span').html(count)
        })


    }

    $$(document).on('change', '#ostans', function () {
        var value = $("#ostans option:selected").val();
        $('#ostans').attr('enable', 'false')
        hnapi.pageContent("/SuperAdmin/GetShahrs?ostanID=" + value, { lazyLoad: true, basketID: basketID, applicationCookieAuth: window.localStorage.getItem('lrCode') }, null, function (data) {
            $('#ostans').attr('enable', 'true')
            $('#ShahrestanID').html(JSON.parse(data));
        })
    })

    menuListView.loadPage('PageContent.html?viewName=menuListView&id=' + hnapi.foodPageMenuID)
    window.localStorage.setItem('applicationVersionID', Template7.global.applicationVersionID);

    window.app = ah7App;
    EachAjaxForm();





    $$(document).on('click', '#useUserCredit', function () {
        $(this).hide();
        $('#userCreditWrapper').addClass('Used')
        var $span = $('#totalPriceWithUserCredit span:last');
        var totalPrice = $('.wrapper_TotalBasePrice .TotalBasePrice').attr('data-totalprice')
        var cleintcredit = $('.wrapper_TotalBasePrice').attr('data-cleintcredit')


        var totalinstallmentprepaymentprice = $('.wrapper_TotalBasePrice').attr('data-totalinstallmentprepaymentprice')
        var totalCashprice = totalPrice - totalinstallmentprepaymentprice
        var currentCredit = parseInt(cleintcredit) - parseInt(totalCashprice);
        if (currentCredit < 0) {
            currentCredit = 0;
            $('#creditAmount').val(cleintcredit)
        }
        else
            $('#creditAmount').val(totalPrice)

        var price = parseInt(totalCashprice) - parseInt(cleintcredit);
        $('#currentUserCredit').html(setPriceCama(currentCredit) + " تومان").show();
        if (price < 0) {
            price = 0;
            //$('#pnlPaymentList, #wrapper_steps .shipping .head h2').hide()
        }
        $span.html(setPriceCama(price) + " تومان");
        $('#totalPriceWithUserCredit').show()
        $('#paymentTotlaPrice').html(setPriceCama(price + parseInt(totalinstallmentprepaymentprice)) + " تومان")
    });

    $$(document).on('click', '#checkDiscountCode', function () {
        $(this).parent().find('.uploadingImage').show();
        $('#loading_img').show()
        var totalbaseprice = $(this).attr('data-totalbaseprice')
        hnapi.pageContent('/SuperAdmin/checkDiscountCode?basketID=' + basketID, {
            totalbaseprice: totalbaseprice,
            code: $(this).parent().find('input[name="DiscountCode"]').val(),
            applicationCookieAuth: window.localStorage.getItem('lrCode')
        }, "Post",
            function (result) {
                $('#loading_img').hide()
                result = JSON.parse(result);
                $('#userCreditWrapper').removeClass('Used')
                $('#currentUserCredit, #totalPriceWithUserCredit').hide();
                $('#useUserCredit').show()
                $('#creditAmount').val('')

                $('.uploadingImage').hide();
                $('#discountResualt_wrapper,#discountResualt_error').hide();


                var discountPercent = 0;
                if (!result.sunccess) {
                    $('#discountResualt_error').show().html(result.message)
                }
                else {
                    if (result.discountPercent > 0) {

                        $('#discountResualt_wrapper').show();
                        if (result.discountPercent <= 100) {
                            $('#discountPercent').html(result.discountPercent + ' درصد')
                        }
                        else {
                            $('#discountPercent').html(result.discountPercent + ' تومان')
                        }
                     
                        discountPercent = result.discountPercent;

                    }
                }

                var price = parseInt($('#checkDiscountCode').attr('data-totalbaseprice'));
                var totalinstallmentprepaymentprice = parseInt($('#checkDiscountCode').attr('data-totalinstallmentprepaymentprice'));
                var usergroupdiscount = parseInt($('#checkDiscountCode').attr('data-usergroupdiscount'));
                var currentPrice = price - (price * (discountPercent + usergroupdiscount) / 100) + totalinstallmentprepaymentprice;
                $('#totalPriceWithUserCredit span:last').attr('data-discountprice', currentPrice)
                $('#paymentTotlaPrice').html(setPriceCama(currentPrice) + " تومان")

                if (usergroupdiscount > 0 || discountPercent > 0)
                    $('#paymentTotlaPrice').prev().show()
                else
                    $('#paymentTotlaPrice').prev().hide()

                var postPrice = $('#checkDiscountCode').attr('data-postprice')

                var payablePrice = currentPrice;
                if (postPrice != "رایگان" && postPrice != "پس کرایه")
                    payablePrice += parseInt(postPrice);

                $('#payablePrice').html(setPriceCama(payablePrice) + " تومان")
                $('.wrapper_TotalBasePrice .TotalBasePrice').html(setPriceCama(payablePrice - totalinstallmentprepaymentprice) + " تومان").attr('data-totalprice', payablePrice - totalinstallmentprepaymentprice)


            })



    })











    function compileTemplate(temp, data) {
        var compiledTemplate = Template7.compile($$(temp).html());
        return compiledTemplate(data);
    }


    function Food_userAuthentication() {
        $('#login_wrapper').html(compileTemplate('#Food_CheckPhoneNumber-temp', { call: false, ForgetPass: false }));
        EachAjaxForm();
    }


    window.afterFoodPhoneNumberVerification = function afterFoodPhoneNumberVerification($form, data) {
        if ($form.find('input[name="call"]').val() == "false") {
            if (data.status == "enterPass") {
                $('#login_wrapper').html(
                    compileTemplate('#Food_PassVerification-temp', { PhoneNumber: $form.find('input[name="PhoneNumber"]').val() }));
                EachAjaxForm();
                $('#profileView input[name="password"]').focus()
            }
            else if (data.status == "enterVerificationCode") {
                $('#login_wrapper').html(
                    compileTemplate('#Food_PhoneVerification-temp', {
                        PhoneNumber: $form.find('input[name="PhoneNumber"]').val(),
                        ForgetPass: $form.find('input[name="ForgetPass"]').val()
                    })
                );
                EachAjaxForm();
                setPhoneNumberWatting()
                $('#profileView #checkCodePhoneNumber').focus()
            }
        }

    }

    window.afterCheckFoodPhoneVerification = function afterCheckFoodPhoneVerification($form, data) {
        $('.codePhoneNumber_loadding').removeClass('active')
        if (data.status == "maxAttemptForPhoneVerification") {
        }
        else if (data.status == "register") {
            $('#login_wrapper').html(
                compileTemplate('#Food_registerUser-temp', {
                    PhoneNumber: $form.find('input[name="PhoneNumber"]').val(),
                    ForgetPass: false,
                    verificationCode: data.code
                })
            );
            EachAjaxForm();
        }
        else if (data.status == "incorrect") {
        }
        else if (data.status == "resetPass") {
            $('#login_wrapper').html(
                compileTemplate('#Food_resetPassword-temp', {
                    PhoneNumber: $form.find('input[name="PhoneNumber"]').val(),
                    ForgetPass: false,
                    verificationCode: data.code
                }));

            EachAjaxForm();
            setPhoneNumberWatting()
        }
        else if (data.status == "success") {
            foodIsauthenticated()
        }

    }
    window.failedCheckFoodPhoneVerification = function failedCheckFoodPhoneVerification() {
        $('.codePhoneNumber_loadding').removeClass('active')
    }
    $$(document).on('blur', '#checkCodePhoneNumber', function () {
        checkCodePhoneNumber(this)
    });

    $$(document).on('keyup', '#checkCodePhoneNumber', function () {
        checkCodePhoneNumber(this)
    });
    window.checkCodePhoneNumber = function checkCodePhoneNumber(current) {
        if (!$(current).next().hasClass('active')) {
            var value = $(current).val()
            if (value.length == 5) {
                $(current).next().addClass('active')
                $(current).parent().parent().find('button[type="submit"]').click()
            }
        }
    }
    $$(document).on('click', '.callForPhoneVerificationCode:not(.disabled)', function () {
        $(this).prev().show()
        $(this).addClass('disabled')
        $('#login_wrapper').append(
            compileTemplate('#Food_CheckPhoneNumber-temp', {
                call: true,
                ForgetPass: false,
                PhoneNumber: $('form[fuction-success="afterCheckFoodPhoneVerification"]').find('input[name="PhoneNumber"]').val()
            })

        );
        EachAjaxForm();
        var $form = $('form[fuction-success="afterFoodPhoneNumberVerification"]');
        $form.hide();
        $form.find('button[type="submit"]').click()
    })
    $$(document).on('click', '.foodPasRecoverSms', function () {
        var r = confirm("کد تایید جهت بازیابی رمز عبور ارسال شود؟");

        if (r == true) {
            var phoneNumber = $(this).prev().find('input[name="PhoneNumber"]').val()

            $('#login_wrapper').append(
                compileTemplate('#Food_CheckPhoneNumber-temp', {
                    call: false,
                    ForgetPass: true,
                    PhoneNumber: phoneNumber
                })

            );
            EachAjaxForm();
            var $form = $('form[fuction-success="afterFoodPhoneNumberVerification"]');
            $form.hide();
            $form.find('button[type="submit"]').click()

        }
    })

    function setPhoneNumberWatting() {
        var number = 30;
        var waittingInterval = setInterval(function () {
            number--;
            $('.codeWaitingCountDown').html(number)
            if (number == 0) {
                clearInterval(waittingInterval);
                $('.codeWaitingCountDown').parent().hide()
                $('.callForPhoneVerificationCode').show()
            }
        }, 1000)
    }
    window.afterCheckFoodPassVerification = function afterCheckFoodPassVerification($form, data) {
        saveUserData(data)
        foodIsauthenticated()
    }

    window.afterFoodResetPass = function afterFoodResetPass($form, data) {
        saveUserData(data)
        foodIsauthenticated()
    }

    window.afterRegisterUser = function afterRegisterUser($form, data) {
        saveUserData(data)
        foodIsauthenticated()
    }

    function saveUserData(data) {
      //  setCookie("lrCode", data.lrCode );
      
        window.localStorage.setItem('lrCode', data.lrCode , 30 );
        window.localStorage.setItem('fullName', data.fullName);
        $$('.panel.panel-right.panel-reveal .content-block-title a').html(data.fullName)
    }

    function setCookie(cname, cvalue, exdays) {
        var d = new Date();
        d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
        var expires = "expires=" + d.toUTCString();
        document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
    }
    function foodIsauthenticated() {
        $('#loading_img').hide();

        if (resaultLoginPage == "submitChart") {
            ah7App.showTab('#bascketView');
            bascketView.loadPage('AddressReview.html')
            // bascketView.loadPage('chartFinalizing.html')
        }
        else {
            // profileView.back()
            setProfileInfo()
        }
    }


    //    var requestedBytes = 1024 * 1024 * 280;

    //    navigator.webkitPersistentStorage.requestQuota(
    //        requestedBytes, function (grantedBytes) {
    //            window.webkitRequestFileSystem(PERSISTENT, grantedBytes, function (fs)
    //            {
    //                console.log('file system open: ' + fs.name);
    //                getSampleFile(fs.root);

    //            }, onErrorLoadFs);

    //        }, function (e) { console.log('Error', e); }
    //    );


    //    document.addEventListener("deviceready", function () {

    //        window.requestFileSystem(window.TEMPORARY, 5 * 1024 * 1024, function (fs) {

    //            console.log('file system open: ' + fs.name);
    //            getSampleFile(fs.root);

    //        }, onErrorLoadFs);

    //    }, false);


    //    function onErrorLoadFs(fileSystem) {
    //        console.log(fileSystem.name);
    //    }

    //    function getSampleFile(dirEntry) {

    //        var xhr = new XMLHttpRequest();
    //        xhr.open('GET', 'http://manhattan-grill.com/Content/base/dynamic/shopping519/img/welcome1.jpg', true);
    //        xhr.responseType = 'blob';

    //        xhr.onload = function () {
    //            if (this.status == 200) {

    //                var blob = new Blob([this.response], { type: 'image/png' });
    //                saveFile(dirEntry, blob, "downloadedImage.png");
    //            }
    //        };
    //        xhr.send();
    //    }



    //    function saveFile(dirEntry, fileData, fileName) {

    //        dirEntry.getFile(fileName, { create: true, exclusive: false }, function (fileEntry) {

    //            writeFile(fileEntry, fileData);

    //        }, onErrorCreateFile);
    //    }
    //    function onErrorCreateFile(fileSystem) {
    //        console.log(fileSystem.name);
    //    }
    //    function onErrorReadFile(fileSystem)
    //    {
    //        console.log(fileSystem.name);
    //    }
    //    function writeFile(fileEntry, dataObj, isAppend) {

    //        // Create a FileWriter object for our FileEntry (log.txt).
    //        fileEntry.createWriter(function (fileWriter) {

    //            fileWriter.onwriteend = function () {
    //                console.log("Successful file write...");
    //                //if (dataObj.type == "image/png") {
    //                //    readBinaryFile(fileEntry);
    //                //}
    //                //else {
    //                //    readFile(fileEntry);
    //                //}
    //            };

    //            fileWriter.onerror = function (e) {
    //                console.log("Failed file write: " + e.toString());
    //            };

    //            fileWriter.write(dataObj);
    //        });
    //    }

    //    function readBinaryFile(fileEntry) {

    //        fileEntry.file(function (file) {
    //            var reader = new FileReader();

    //            reader.onloadend = function () {

    //                console.log("Successful file write: " + this.result);
    //               // displayFileData(fileEntry.fullPath + ": " + this.result);

    //                var blob = new Blob([new Uint8Array(this.result)], { type: "image/png" });
    //                var a = window.URL.createObjectURL(blob);
    //                displayImage(a);
    //            };

    //            reader.readAsArrayBuffer(file);

    //        }, onErrorReadFile);
    //    }


    //    function displayImage(blob) {

    //    // Displays image if result is a valid DOM string for an image.
    //    var elem = document.getElementById('imageFile');
    //    // Note: Use window.URL.revokeObjectURL when finished with image.
    //    elem.src = blob;
    //}



    function getPersianDate(datetime, dateKind) {
        if (datetime == null || datetime == "")
            return "";
        var dateObj = new Date(parseInt(datetime.substr(6)));

        var dateString;
        if ($('body').hasClass('enSite')) {
            dateString = dateObj.getFullYear() + "-" + dateObj.getMonth() + "-" + dateObj.getDate();
        }
        else {
            var checkDate = toJalaali(dateObj.getFullYear(), dateObj.getMonth() + 1, dateObj.getDate());
            dateString = checkDate.jy.toString() + "/" + pad(checkDate.jm.toString(), 2) + "/" + pad(checkDate.jd.toString(), 2);

        }
        var timeString = dateObj.toTimeString().substring(0, 8);

        if (dateKind == "onlyDate")
            return dateString;
        if (dateKind == "onlyTime")
            return timeString;

        return dateString + ($('body').hasClass('enSite') ? " " : " در ساعت ") + timeString
    }



    // ------------  toJalaali --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    function toJalaali(gy, gm, gd) {
        return d2j(g2d(gy, gm, gd))
    }

    /*
      Converts a Jalaali date to Gregorian.
    */
    function toGregorian(jy, jm, jd) {
        return d2g(j2d(jy, jm, jd))
    }

    /*
      Checks whether a Jalaali date is valid or not.
    */
    function isValidJalaaliDate(jy, jm, jd) {
        return jy >= -61 && jy <= 3177 &&
            jm >= 1 && jm <= 12 &&
            jd >= 1 && jd <= jalaaliMonthLength(jy, jm)
    }

    /*
      Is this a leap year or not?
    */
    function isLeapJalaaliYear(jy) {
        return jalCal(jy).leap === 0
    }

    /*
      Number of days in a given month in a Jalaali year.
    */
    function jalaaliMonthLength(jy, jm) {
        if (jm <= 6) return 31
        if (jm <= 11) return 30
        if (isLeapJalaaliYear(jy)) return 30
        return 29
    }

    /*
      This function determines if the Jalaali (Persian) year is
      leap (366-day long) or is the common year (365 days), and
      finds the day in March (Gregorian calendar) of the first
      day of the Jalaali year (jy).
    
      @param jy Jalaali calendar year (-61 to 3177)
      @return
        leap: number of years since the last leap year (0 to 4)
        gy: Gregorian year of the beginning of Jalaali year
        march: the March day of Farvardin the 1st (1st day of jy)
      @see: http://www.astro.uni.torun.pl/~kb/Papers/EMP/PersianC-EMP.htm
      @see: http://www.fourmilab.ch/documents/calendar/
    */
    function jalCal(jy) {
        // Jalaali years starting the 33-year rule.
        var breaks = [-61, 9, 38, 199, 426, 686, 756, 818, 1111, 1181, 1210
            , 1635, 2060, 2097, 2192, 2262, 2324, 2394, 2456, 3178
        ]
            , bl = breaks.length
            , gy = jy + 621
            , leapJ = -14
            , jp = breaks[0]
            , jm
            , jump
            , leap
            , leapG
            , march
            , n
            , i

        if (jy < jp || jy >= breaks[bl - 1])
            throw new Error('Invalid Jalaali year ' + jy)

        // Find the limiting years for the Jalaali year jy.
        for (i = 1; i < bl; i += 1) {
            jm = breaks[i]
            jump = jm - jp
            if (jy < jm)
                break
            leapJ = leapJ + div(jump, 33) * 8 + div(mod(jump, 33), 4)
            jp = jm
        }
        n = jy - jp

        // Find the number of leap years from AD 621 to the beginning
        // of the current Jalaali year in the Persian calendar.
        leapJ = leapJ + div(n, 33) * 8 + div(mod(n, 33) + 3, 4)
        if (mod(jump, 33) === 4 && jump - n === 4)
            leapJ += 1

        // And the same in the Gregorian calendar (until the year gy).
        leapG = div(gy, 4) - div((div(gy, 100) + 1) * 3, 4) - 150

        // Determine the Gregorian date of Farvardin the 1st.
        march = 20 + leapJ - leapG

        // Find how many years have passed since the last leap year.
        if (jump - n < 6)
            n = n - jump + div(jump + 4, 33) * 33
        leap = mod(mod(n + 1, 33) - 1, 4)
        if (leap === -1) {
            leap = 4
        }

        return {
            leap: leap
            , gy: gy
            , march: march
        }
    }

    /*
      Converts a date of the Jalaali calendar to the Julian Day number.
    
      @param jy Jalaali year (1 to 3100)
      @param jm Jalaali month (1 to 12)
      @param jd Jalaali day (1 to 29/31)
      @return Julian Day number
    */
    function j2d(jy, jm, jd) {
        var r = jalCal(jy)
        return g2d(r.gy, 3, r.march) + (jm - 1) * 31 - div(jm, 7) * (jm - 7) + jd - 1
    }

    /*
      Converts the Julian Day number to a date in the Jalaali calendar.
    
      @param jdn Julian Day number
      @return
        jy: Jalaali year (1 to 3100)
        jm: Jalaali month (1 to 12)
        jd: Jalaali day (1 to 29/31)
    */
    function d2j(jdn) {
        var gy = d2g(jdn).gy // Calculate Gregorian year (gy).
            , jy = gy - 621
            , r = jalCal(jy)
            , jdn1f = g2d(gy, 3, r.march)
            , jd
            , jm
            , k

        // Find number of days that passed since 1 Farvardin.
        k = jdn - jdn1f
        if (k >= 0) {
            if (k <= 185) {
                // The first 6 months.
                jm = 1 + div(k, 31)
                jd = mod(k, 31) + 1
                return {
                    jy: jy
                    , jm: jm
                    , jd: jd
                }
            } else {
                // The remaining months.
                k -= 186
            }
        } else {
            // Previous Jalaali year.
            jy -= 1
            k += 179
            if (r.leap === 1)
                k += 1
        }
        jm = 7 + div(k, 30)
        jd = mod(k, 30) + 1
        return {
            jy: jy
            , jm: jm
            , jd: jd
        }
    }

    /*
      Calculates the Julian Day number from Gregorian or Julian
      calendar dates. This integer number corresponds to the noon of
      the date (i.e. 12 hours of Universal Time).
      The procedure was tested to be good since 1 March, -100100 (of both
      calendars) up to a few million years into the future.
    
      @param gy Calendar year (years BC numbered 0, -1, -2, ...)
      @param gm Calendar month (1 to 12)
      @param gd Calendar day of the month (1 to 28/29/30/31)
      @return Julian Day number
    */
    function g2d(gy, gm, gd) {
        var d = div((gy + div(gm - 8, 6) + 100100) * 1461, 4)
            + div(153 * mod(gm + 9, 12) + 2, 5)
            + gd - 34840408
        d = d - div(div(gy + 100100 + div(gm - 8, 6), 100) * 3, 4) + 752
        return d
    }

    /*
      Calculates Gregorian and Julian calendar dates from the Julian Day number
      (jdn) for the period since jdn=-34839655 (i.e. the year -100100 of both
      calendars) to some millions years ahead of the present.
    
      @param jdn Julian Day number
      @return
        gy: Calendar year (years BC numbered 0, -1, -2, ...)
        gm: Calendar month (1 to 12)
        gd: Calendar day of the month M (1 to 28/29/30/31)
    */
    function d2g(jdn) {
        var j
            , i
            , gd
            , gm
            , gy
        j = 4 * jdn + 139361631
        j = j + div(div(4 * jdn + 183187720, 146097) * 3, 4) * 4 - 3908
        i = div(mod(j, 1461), 4) * 5 + 308
        gd = div(mod(i, 153), 5) + 1
        gm = mod(div(i, 153), 12) + 1
        gy = div(j, 1461) - 100100 + div(8 - gm, 6)
        return {
            gy: gy
            , gm: gm
            , gd: gd
        }
    }

    /*
      Utility helper functions.
    */

    function div(a, b) {
        return ~~(a / b)
    }

    function mod(a, b) {
        return a - ~~(a / b) * b
    }
    // ------ end toJalaali ---------------------------------------------------------------------------------------------------------------------------------------------------------------------

    function AmazingofferContentLoad($elem) {
        $elem.find('.amazingoffer  .clock').each(function () {
            var $this = $(this);
            var countDownDate = $(this).attr('data-expiredatetime')
            countDownDate = parseInt(countDownDate.substring(6, countDownDate.length - 2))

            var oldDays, oldHours, oldMinutes, oldSeconds
            resetClockAmazzing($this, countDownDate, oldDays, oldHours, oldMinutes, oldSeconds);
            var x = setInterval(function () {
                resetClockAmazzing($this, countDownDate, oldDays, oldHours, oldMinutes, oldSeconds)
            }, 1000);

        })
    }
    function resetClockAmazzing($this, countDownDate, oldDays, oldHours, oldMinutes, oldSeconds) {

        var now = new Date().getTime();
        var distance = countDownDate - now;
        var days = Math.floor(distance / (1000 * 60 * 60 * 24));
        var hours = Math.floor((distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
        var minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));
        var seconds = Math.floor((distance % (1000 * 60)) / 1000);

        hours = pad(hours, 2);
        minutes = pad(minutes, 2);
        seconds = pad(seconds, 2);

        if (oldDays == null) {
            oldDays = days; oldHours = hours; oldMinutes = minutes; oldSeconds = seconds;
        }

        if (distance >= 0) {
            $this.html((days >= 0 ? '<span class="countDown_day">' + countdownValue(days, oldDays) + '<label>روز</label></span>' : '') +
                '<span class="countDown_hour">' + countdownValue(hours, oldHours) + '<label>ساعت</label></span>' +
                '<span class="countDown_minute">' + countdownValue(minutes, oldMinutes) + '<label>دقیقه</label></span>' +
                '<span class="countDown_secound">' + countdownValue(seconds, oldSeconds) + '<label>ثانیه</label></span>')

            oldDays = days; oldHours = hours; oldMinutes = minutes; oldSeconds = seconds
        }
        else {
            $this.html("به اتمام رسیده")
            var $slide = $this.parent().parent().parent().parent();
            var index = $slide.index();
            $slide.parent().parent().parent().find('.slidesjs-pagination li:eq(' + index + ')').remove()
            $slide.remove();
        }
    }
    function countdownValue(newValue, oldValue) {

        var output = "";
        for (var i = 0; i < newValue.toString().length; i++) {
            var nValue = newValue.toString()[i];
            var oValue = oldValue.toString()[i];
            output += '<span class="' + (nValue == oValue ? "" : 'animated') + '"><span class="newCountDown"  >' + nValue + '</span><span class="oldCountDown"  >' + oValue + '</span></span>'
        }
        return output
    }


    function pad(value, length) {
        return (value.toString().length < length) ? pad("0" + value, length) : value;
    }

}(Framework7, Dom7, Template7, moment, hnapi));


